
Require Import Tactics.
Require Import Sequence.
Require Import Static.
Require Import TSubst.
Require Import Formation.
Require Import Regularity.
Require Import Algorithm.
Require Import Declarative.

Require Compare_dec.


Fixpoint logk (sk : skeleton) {struct sk} : context -> context -> (* kd *) term -> term -> Prop :=
  (match sk with
   | sk_type =>
       (fun D D' k k' =>
          k = kd_type /\ k' = kd_type)

   | sk_sing =>
       (fun D D' k k' => exists b b',
          k = kd_sing b /\ k' = kd_sing b'
          /\ aeq D D' b b' kd_type kd_type)

   | sk_pi sk1 sk2 =>
       (fun D D' k k' => exists k1 k1' k2 k2',
          k = kd_pi k1 k2 /\ k' = kd_pi k1' k2'
          /\ logk sk1 D D' k1 k1'
          /\ (forall i D2 D2' d d',
                extend i D D2
                -> extend i D' D2'
                -> logc sk1 D2 D2' d d' (subst (sh i) k1) (subst (sh i) k1')
                -> logk sk2 D2 D2' (subst (dot d (sh i)) k2) (subst (dot d' (sh i)) k2'))
          /\ (forall i D2 D2' d d',
                extend i D D2
                -> extend i D D2'
                -> logc sk1 D2 D2' d d' (subst (sh i) k1) (subst (sh i) k1)
                -> logk sk2 D2 D2' (subst (dot d (sh i)) k2) (subst (dot d' (sh i)) k2))
          /\ (forall i D2 D2' d d',
                extend i D' D2
                -> extend i D' D2'
                -> logc sk1 D2 D2' d d' (subst (sh i) k1') (subst (sh i) k1')
                -> logk sk2 D2 D2' (subst (dot d (sh i)) k2') (subst (dot d' (sh i)) k2')))

   | sk_sigma sk1 sk2 =>
       (fun D D' k k' => exists k1 k1' k2 k2',
          k = kd_sigma k1 k2 /\ k' = kd_sigma k1' k2'
          /\ logk sk1 D D' k1 k1'
          /\ (forall i D2 D2' d d',
                extend i D D2
                -> extend i D' D2'
                -> logc sk1 D2 D2' d d' (subst (sh i) k1) (subst (sh i) k1')
                -> logk sk2 D2 D2' (subst (dot d (sh i)) k2) (subst (dot d' (sh i)) k2'))
          /\ (forall i D2 D2' d d',
                extend i D D2
                -> extend i D D2'
                -> logc sk1 D2 D2' d d' (subst (sh i) k1) (subst (sh i) k1)
                -> logk sk2 D2 D2' (subst (dot d (sh i)) k2) (subst (dot d' (sh i)) k2))
          /\ (forall i D2 D2' d d',
                extend i D' D2
                -> extend i D' D2'
                -> logc sk1 D2 D2' d d' (subst (sh i) k1') (subst (sh i) k1')
                -> logk sk2 D2 D2' (subst (dot d (sh i)) k2') (subst (dot d' (sh i)) k2')))

   | sk_one =>
       (fun D D' k k' =>
          k = kd_one /\ k' = kd_one)
   end)


with logc (sk : skeleton) {struct sk} : context -> context -> (* cn *) term -> term -> (* kd *) term -> term -> Prop :=
  (match sk with
   | sk_type =>
       (fun D D' c c' k k' =>
          k = kd_type /\ k' = kd_type
          /\ aeq D D' c c' kd_type kd_type)

   | sk_sing =>
       (fun D D' c c' k k' => exists b b',
          k = kd_sing b /\ k' = kd_sing b'
          /\ aeq D D' b b' kd_type kd_type
          /\ aeq D D' c c' kd_type kd_type
          /\ aeq D D b c kd_type kd_type)

   | sk_pi sk1 sk2 =>
       (fun D D' c c' k k' => exists k1 k1' k2 k2',
          k = kd_pi k1 k2 /\ k' = kd_pi k1' k2'
          /\ logk sk1 D D' k1 k1'
          /\ (forall i D2 D2' d d',
                extend i D D2
                -> extend i D' D2'
                -> logc sk1 D2 D2' d d' (subst (sh i) k1) (subst (sh i) k1')
                -> logc sk2 D2 D2' (cn_app (subst (sh i) c) d) (cn_app (subst (sh i) c') d') (subst (dot d (sh i)) k2) (subst (dot d' (sh i)) k2'))
          /\ (forall i D2 D2' d d',
                extend i D D2
                -> extend i D D2'
                -> logc sk1 D2 D2' d d' (subst (sh i) k1) (subst (sh i) k1)
                -> logc sk2 D2 D2' (cn_app (subst (sh i) c) d) (cn_app (subst (sh i) c) d') (subst (dot d (sh i)) k2) (subst (dot d' (sh i)) k2))
          /\ (forall i D2 D2' d d',
                extend i D' D2
                -> extend i D' D2'
                -> logc sk1 D2 D2' d d' (subst (sh i) k1') (subst (sh i) k1')
                -> logc sk2 D2 D2' (cn_app (subst (sh i) c') d) (cn_app (subst (sh i) c') d') (subst (dot d (sh i)) k2') (subst (dot d' (sh i)) k2')))

   | sk_sigma sk1 sk2 =>
       (fun D D' c c' k k' => exists k1 k1' k2 k2',
          k = kd_sigma k1 k2 /\ k' = kd_sigma k1' k2'
          /\ logc sk1 D D' (cn_pi1 c) (cn_pi1 c') k1 k1'
          /\ logc sk2 D D' (cn_pi2 c) (cn_pi2 c') (subst1 (cn_pi1 c) k2) (subst1 (cn_pi1 c') k2')
          /\ (forall i D2 D2' d d',
                extend i D D2
                -> extend i D' D2'
                -> logc sk1 D2 D2' d d' (subst (sh i) k1) (subst (sh i) k1')
                -> logk sk2 D2 D2' (subst (dot d (sh i)) k2) (subst (dot d' (sh i)) k2'))
          /\ (forall i D2 D2' d d',
                extend i D D2
                -> extend i D D2'
                -> logc sk1 D2 D2' d d' (subst (sh i) k1) (subst (sh i) k1)
                -> logk sk2 D2 D2' (subst (dot d (sh i)) k2) (subst (dot d' (sh i)) k2))
          /\ (forall i D2 D2' d d',
                extend i D' D2
                -> extend i D' D2'
                -> logc sk1 D2 D2' d d' (subst (sh i) k1') (subst (sh i) k1')
                -> logk sk2 D2 D2' (subst (dot d (sh i)) k2') (subst (dot d' (sh i)) k2')))
     
   | sk_one =>
       (fun D D' c c' k k' =>
          k = kd_one /\ k' = kd_one)
   end).


Lemma logc_reg :
  forall sk D D' c c' k k',
    logc sk D D' c c' k k'
    -> logk sk D D' k k'.
Proof.
intros sk.
induct sk.

(* type *)
intros D D' c c' k k' Hlog.
simpl in Hlog.
destruct Hlog as (-> & -> & _).
simpl.
auto; done.

(* sing *)
intros D D' c c' k k' Hlog.
simpl in Hlog.
destruct Hlog as (b & b' & -> & -> & Haeq & _).
simpl.
eauto; done.

(* pi *)
intros sk1 IH1 sk2 IH2 D D' c c' k k' Hlog.
simpl in Hlog.
destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
simpl.
do 4 eexists; do2 5 split; eauto; done.

(* sigma *)
intros sk1 IH1 sk2 IH2 D D' c c' k k' Hlog.
simpl in Hlog.
destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & _ & Hlogk & Hloglk & Hlogkr).
simpl.
do 4 eexists; do2 5 split; eauto; done.

(* one *)
intros D D' c c' k k' Hlog.
simpl in Hlog.
destruct Hlog as (-> & ->).
simpl.
auto; done.
Qed.


Lemma log_mono :
  forall sk,
    (forall i D D' D2 D2' k k',
       extend i D D2
       -> extend i D' D2'
       -> logk sk D D' k k'
       -> logk sk D2 D2' (subst (sh i) k) (subst (sh i) k'))
    /\
    (forall i D D' D2 D2' c c' k k',
       extend i D D2
       -> extend i D' D2'
       -> logc sk D D' c c' k k'
       -> logc sk D2 D2' (subst (sh i) c) (subst (sh i) c') (subst (sh i) k) (subst (sh i) k')).
Proof.
intro sk.
induct sk.

(* type *)
split.
  intros i D1 D1' D2 D2' k k' Hext Hext' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  simp_sub.
  simpl.
  auto; done.

  intros i D1 D1' D2 D2' c c' k k' Hext Hext' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & -> & Haeq).
  simpl.
  do2 2 split; auto; [].
  replace kd_type with (subst (sh i) kd_type) by (simp_sub; reflexivity).
  eapply weaken_aeq; eauto; done.

(* sing *)
split.
  intros i D D' D2 D2' k k' Hext Hext' Hlog.
  simpl in Hlog.
  destruct Hlog as (b & b' & -> & -> & Haeq).
  simp_sub.
  simpl.
  exists (subst (sh i) b), (subst (sh i) b').
  do2 2 split; auto; [].
  replace kd_type with (subst (sh i) kd_type) by (simp_sub; reflexivity).
  eapply weaken_aeq; eauto; done.

  intros i D D' D2 D2' c c' k k' Hext Hext' Hlog.
  simpl in Hlog.
  destruct Hlog as (b & b' & -> & -> & Haeqb & Haeqc & Haeq).
  simp_sub.
  simpl.
  eexists; eexists.
  do2 4 split; eauto; replace kd_type with (subst (sh i) kd_type) by (simp_sub; reflexivity); eapply weaken_aeq; eauto; done.

(* pi *)
intros sk1 IH1 sk2 IH2.
split.
  intros i D D' D2 D2' k k' Hext Hext' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  simp_sub.
  simpl.
  #4 do 4 eexists; do2 5 split; eauto.
    eapply (IH1 andel); eauto; done.

    intros j D3 D3' d d' Hext3 Hext3' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply Hlog2; eauto using extend_trans; done.

    intros j D3 D3' d d' Hext3 Hext3' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply Hlog2l; eauto using extend_trans; done.

    intros j D3 D3' d d' Hext3 Hext3' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply Hlog2r; eauto using extend_trans; done.

  intros i D D' D2 D2' c c' k k' Hext Hext' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  simp_sub.
  simpl.
  #4 do 4 eexists; do2 5 split; eauto.
    eapply (IH1 andel); eauto; done.

    intros j D3 D3' d d' Hext3 Hext3' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply Hlog2; eauto using extend_trans; done.

    intros j D3 D3' d d' Hext3 Hext3' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply Hlog2l; eauto using extend_trans; done.

    intros j D3 D3' d d' Hext3 Hext3' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply Hlog2r; eauto using extend_trans; done.

(* sigma *)
intros sk1 IH1 sk2 IH2.
split.
  intros i D D' D2 D2' k k' Hext Hext' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  simp_sub.
  simpl.
  #4 do 4 eexists; do2 5 split; eauto.
    eapply (IH1 andel); eauto; done.

    intros j D3 D3' d d' Hext3 Hext3' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply Hlog2; eauto using extend_trans; done.

    intros j D3 D3' d d' Hext3 Hext3' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply Hlog2l; eauto using extend_trans; done.

    intros j D3 D3' d d' Hext3 Hext3' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply Hlog2r; eauto using extend_trans; done.

  intros i D D' D2 D2' c c' k k' Hext Hext' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlogk & Hlogkl & Hlogkr).
  simp_sub.
  simpl.
  #5 do 4 eexists; do2 6 split; eauto.
    so (IH1 ander _#9 Hext Hext' Hlog1) as Hlog1'.
    simp_sub in Hlog1'.
    assumption.

    so (IH2 ander _#9 Hext Hext' Hlog2) as Hlog2'.
    simp_sub in Hlog2'.
    simp_sub.
    assumption.

    intros j D3 D3' d d' Hext3 Hext3' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply Hlogk; eauto using extend_trans; done.

    intros j D3 D3' d d' Hext3 Hext3' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply Hlogkl; eauto using extend_trans; done.

    intros j D3 D3' d d' Hext3 Hext3' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply Hlogkr; eauto using extend_trans; done.

(* one *)
split.
  intros i D D' D2 D2' k k' _ _ Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  simpl.
  simp_sub; auto; done.

  intros i D D' D2 D2' c c' k k' _ _ Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  simpl.
  simp_sub; auto; done.
Qed.


Lemma logk_mono :
  forall sk i D D' D2 D2' k k',
    extend i D D2
    -> extend i D' D2'
    -> logk sk D D' k k'
    -> logk sk D2 D2' (subst (sh i) k) (subst (sh i) k').
Proof.
intro sk.
exact (log_mono sk andel).
Qed.


Lemma logc_mono :
  forall sk i D D' D2 D2' c c' k k',
    extend i D D2
    -> extend i D' D2'
    -> logc sk D D' c c' k k'
    -> logc sk D2 D2' (subst (sh i) c) (subst (sh i) c') (subst (sh i) k) (subst (sh i) k').
Proof.
intro sk.
exact (log_mono sk ander).
Qed.


Lemma log_symm :
  forall sk,
    (forall D D' k k',
       logk sk D D' k k'
       -> logk sk D' D k' k)
    /\
    (forall D D' c c' k k',
       logc sk D D' c c' k k'
       -> logc sk D' D c' c k' k).
Proof.
intro sk.
induct sk.

(* type *)
split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  simpl.
  auto; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & -> & Haeq).
  simpl.
  auto using aeq_symm; done.

(* sing *)
split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (b & b' & -> & -> & Haeq).
  simpl.
  do 2 eexists; do2 2 split; eauto using aeq_symm; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (b & b' & -> & -> & Haeqb & Haeqc & Haeqbc).
  simpl.
  do 2 eexists; do2 4 split; eauto using aeq_trans, aeq_symm; done.

(* pi *)
intros sk1 IH1 sk2 IH2.
split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  simpl.
  #2 do 4 eexists; do2 5 split; eauto.
    apply (IH1 andel); auto; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    apply (IH2 andel); auto; [].
    apply Hlog2; auto; [].
    apply (IH1 ander); auto; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  simpl.
  #2 do 4 eexists; do2 5 split; eauto.
    apply (IH1 andel); auto; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    apply (IH2 ander); auto; [].
    apply Hlog2; auto; [].
    apply (IH1 ander); auto; done.

(* sigma *)
intros sk1 IH1 sk2 IH2.
split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  simpl.
  #2 do 4 eexists; do2 5 split; eauto.
    apply (IH1 andel); auto; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    apply (IH2 andel); auto; [].
    apply Hlog2; auto; [].
    apply (IH1 ander); auto; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2k & Hlog2kl & Hlog2kr).
  simpl.
  #3 do 4 eexists; do2 5 split; eauto.
    apply (IH1 ander); auto; done.

    apply (IH2 ander); auto; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    apply (IH2 andel); auto; [].
    apply Hlog2k; auto; [].
    apply (IH1 ander); auto; done.

(* one *)
split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  simpl.
  auto; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  simpl.
  auto; done.
Qed.


Lemma logk_symm :
  forall sk D D' k k',
    logk sk D D' k k'
    -> logk sk D' D k' k.
Proof.
intro sk.
exact (log_symm sk andel).
Qed.


Lemma logc_symm :
  forall sk D D' c c' k k',
    logc sk D D' c c' k k'
    -> logc sk D' D c' c k' k.
Proof.
intro sk.
exact (log_symm sk ander).
Qed.


Lemma log_self :
  forall sk,
    (forall D D' k k',
       logk sk D D' k k'
       -> logk sk D D k k)
    /\
    (forall D D' c c' k k',
       logc sk D D' c c' k k'
       -> logc sk D D c c k k).
Proof.
intro sk.
induct sk.

(* type *)
split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  simpl.
  auto; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & -> & Haeq).
  simpl.
  eauto using aeq_self_left; done.

(* sing *)
split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (b & b' & -> & -> & Haeq).
  simpl.
  exists b, b.
  do2 2 split; auto; [].
  eapply aeq_self_left; eauto; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (b & b' & -> & -> & Haeqb & Haeqc & Haeqbc).
  simpl.
  exists b, b.
  do2 4 split; eauto using aeq_self_left; done.

(* pi *)
intros sk1 IH1 sk2 IH2.
split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  simpl.
  do 4 eexists; do2 5 split; eauto; [].
  eapply (IH1 andel); eauto; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  simpl.
  do 4 eexists; do2 5 split; eauto; [].
  eapply (IH1 andel); eauto; done.

(* sigma *)
intros sk1 IH1 sk2 IH2.
split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  simpl.
  do 4 eexists; do2 5 split; eauto; [].
  eapply (IH1 andel); eauto; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2k & Hlog2kl & Hlog2kr).
  simpl.
  #2 do 4 eexists; do2 5 split; eauto.
    eapply (IH1 ander); eauto; done.

    eapply (IH2 ander); eauto; done.

(* one *)
split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  simpl.
  auto; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  simpl.
  auto; done.
Qed.


Lemma logk_self_left :
  forall sk D D' k k',
    logk sk D D' k k'
    -> logk sk D D k k.
Proof.
intro sk.
exact (log_self sk andel).
Qed.


Lemma logk_self_right :
  forall sk D D' k k',
    logk sk D D' k k'
    -> logk sk D' D' k' k'.
Proof.
intros sk D D' k k' Hlog.
eapply logk_self_left; [].
apply logk_symm; [].
eassumption.
Qed.


Lemma logc_self_left :
  forall sk D D' c c' k k',
    logc sk D D' c c' k k'
    -> logc sk D D c c k k.
Proof.
intro sk.
exact (log_self sk ander).
Qed.


Lemma logc_self_right :
  forall sk D D' c c' k k',
    logc sk D D' c c' k k'
    -> logc sk D' D' c' c' k' k'.
Proof.
intros sk D D' c c' k k' Hlog.
eapply logc_self_left; [].
apply logc_symm; [].
eassumption.
Qed.


(* Trans and adjust don't have to be done at once, but it's easier. *)
Lemma log_trans_adjust :
  forall sk,
    (forall D1 D3 k1 k2 k3,
       logk sk D1 D1 k1 k2
       -> logk sk D1 D3 k2 k3
       -> logk sk D1 D3 k1 k3)
    /\
    (forall D1 D3 c1 c2 c3 k1 k2 k3,
       logc sk D1 D1 c1 c2 k1 k2
       -> logc sk D1 D3 c2 c3 k2 k3
       -> logc sk D1 D3 c1 c3 k1 k3)
    /\
    (forall D D' c c' l k k',
       logk sk D D l k
       -> logc sk D D' c c' l k'
       -> logc sk D D' c c' k k').
Proof.
intro sk.
induct sk.

(* type *)
do2 2 split.
  intros D D' k k' k'' Hlog Hlog'.
  simpl in Hlog, Hlog'.
  destruct Hlog as (-> & ->).
  destruct Hlog' as (_ & ->).
  simpl.
  auto; done.

  intros D D' c c' c'' k k' k'' Hlog Hlog'.
  simpl in Hlog, Hlog'.
  destruct Hlog as (-> & -> & Haeq).
  destruct Hlog' as (_ & -> & Haeq').
  simpl.
  eauto using aeq_trans; done.

  intros D D' c c' l k k' Hlogk Hlog.
  simpl in Hlog, Hlogk.
  destruct Hlogk as (-> & ->).
  destruct Hlog as (_ & -> & Haeq).
  simpl.
  do2 2 split; auto; done.

(* sing *)
do2 2 split.
  intros D D' k k' k'' Hlog Hlog'.
  simpl in Hlog, Hlog'.
  destruct Hlog as (b & b' & -> & -> & Haeq).
  destruct Hlog' as (e & b'' & Heq & -> & Haeq').
  injection Heq; clear Heq; intros; subst e.
  simpl.
  do 2 eexists; do2 2 split; eauto; [].
  eapply aeq_trans; eauto; done.

  intros D D' c c' c'' k k' k'' Hlog Hlog'.
  simpl in Hlog, Hlog'.
  destruct Hlog as (b & b' & -> & -> & Haeqb & Haeqc & Haeqbc).
  destruct Hlog' as (e & b'' & Heq & -> & Haeqb' & Haeqc' & Haeqbc').
  injection Heq; clear Heq; intros; subst e.
  simpl.
  do 2 eexists; do2 4 split; eauto using aeq_trans; done.

  intros D D' c c' l k k' Hlogk Hlog.
  simpl in Hlog, Hlogk.
  destruct Hlogk as (d & b & -> & -> & Haeq).
  destruct Hlog as (e & b' & Heq & -> & Haeqb & Haeqc & Haeqbc).
  injection Heq; clear Heq; intros; subst e.
  simpl.
  do 2 eexists; do2 4 split; eauto using aeq_trans, aeq_symm; done.

(* pi *)
intros sk1 IH1 sk2 IH2.
do2 2 split.
  intros D D' k k' k'' Hlog Hlog'.
  simpl in Hlog, Hlog'.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  destruct Hlog' as (e1 & k1'' & e2 & k2'' & Heq & -> & Hlog1' & Hlog2' & Hlog2l' & Hlog2r').
  injection Heq; intros; subst e1 e2; clear Heq.
  simpl.
  #2 do 4 eexists; do2 5 split; eauto.
    eapply IH1; eauto; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    #2 apply (IH2 andel _ _ _ (subst (dot d (sh i)) k2')).
      apply Hlog2; auto; [].
      apply logc_symm; [].
      apply (IH1 ander ander _#4 (subst (sh i) k1)); eauto using logk_mono, logk_self_left, logc_self_left, logc_reg; done.

      apply Hlog2'; auto; [].
      apply (IH1 ander ander _#4 (subst (sh i) k1)); eauto using logk_mono, logk_self_right, logc_self_left, logc_reg; done.

  intros D D' c c' c'' k k' k'' Hlog Hlog'.
  simpl in Hlog, Hlog'.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  destruct Hlog' as (e1 & k1'' & e2 & k2'' & Heq & -> & Hlog1' & Hlog2' & Hlog2l' & Hlog2r').
  injection Heq; intros; subst e1 e2; clear Heq.
  simpl.
  #2 do 4 eexists; do2 5 split; eauto.
    eapply IH1; eauto; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    #2 apply (IH2 ander andel _ _ _ (cn_app (subst (sh i) c') d) _ _ (subst (dot d (sh i)) k2')).
      apply Hlog2; auto; [].
      apply logc_symm; [].
      apply (IH1 ander ander _#4 (subst (sh i) k1)); eauto using logk_mono, logk_self_left, logc_self_left, logc_reg; done.

      apply Hlog2'; auto; [].
      apply (IH1 ander ander _#4 (subst (sh i) k1)); eauto using logk_mono, logk_self_right, logc_self_left, logc_reg; done.

  intros D D' c c' l k k' Hlogk Hlog.
  simpl in Hlog, Hlogk.
  destruct Hlogk as (l1 & k1 & l2 & k2 & -> & -> & Hlogl1 & Hlogl2 & Hlogl2l & Hlogl2r).
  destruct Hlog as (e1 & k1' & e2 & k2' & Heq & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  injection Heq; clear Heq; intros; subst e1 e2.
  simpl.
  #3 do 4 eexists; do2 5 split; eauto.
    eapply (IH1 andel); eauto using logk_symm; done.
  
    intros i D2 D2' d d' Hext Hext' Hlogd.
    #2 apply (IH2 ander ander _#4 (subst (dot d (sh i)) l2)).
      apply Hlogl2; auto; [].
      #2 apply (IH1 ander ander _#4 (subst (sh i) k1)).
        apply logk_symm; [].
        eapply logk_mono; eauto; done.
  
        eapply logc_self_left; eauto; done.
  
      apply Hlog2; auto; [].
      apply (IH1 ander ander _#4 (subst (sh i) k1)); auto; [].
      apply logk_symm; [].
      eapply logk_mono; eauto; done.
  
    intros i D2 D2' d d' Hext Hext' Hlogd.
    assert (logk sk1 D2 D2 (subst (sh i) k1) (subst (sh i) l1)) as Hlogk1l1.
      apply logk_symm; [].
      eapply logk_mono; eauto; done.
    assert (logk sk1 D2' D2' (subst (sh i) k1) (subst (sh i) l1)) as Hlogk1l1'.
      apply logk_symm; [].
      eapply logk_mono; eauto; done.
    #2 apply (IH2 ander ander _#4 (subst (dot d (sh i)) l2)).
      apply Hlogl2; auto; [].
      apply (IH1 ander ander _#4 (subst (sh i) k1)); auto; [].
      eapply logc_self_left; eauto; done.
  
      apply logc_symm; [].
      #2 apply (IH2 ander ander _#4 (subst (dot d' (sh i)) l2)).
        apply Hlogl2; auto; [].
        apply (IH1 ander ander _#4 (subst (sh i) k1)); auto; [].
        eapply logc_self_right; eauto; done.
  
        apply logc_symm; [].
        apply Hlog2l; auto; [].
        apply (IH1 ander ander _#4 (subst (sh i) k1)); auto; [].
        apply logc_symm; [].
        apply (IH1 ander ander _#4 (subst (sh i) k1)); auto; [].
        apply logc_symm; auto; done.

(* sigma *)
intros sk1 IH1 sk2 IH2.
do2 2 split.
  intros D D' k k' k'' Hlog Hlog'.
  simpl in Hlog, Hlog'.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  destruct Hlog' as (e1 & k1'' & e2 & k2'' & Heq & -> & Hlog1' & Hlog2' & Hlog2l' & Hlog2r').
  injection Heq; intros; subst e1 e2; clear Heq.
  simpl.
  #2 do 4 eexists; do2 5 split; eauto.
    eapply IH1; eauto; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    #2 apply (IH2 andel _ _ _ (subst (dot d (sh i)) k2')).
      apply Hlog2; auto; [].
      apply logc_symm; [].
      apply (IH1 ander ander _#4 (subst (sh i) k1)); eauto using logk_mono, logk_self_left, logc_self_left, logc_reg; done.

      apply Hlog2'; auto; [].
      apply (IH1 ander ander _#4 (subst (sh i) k1)); eauto using logk_mono, logk_self_right, logc_self_left, logc_reg; done.

  intros D D' c c' c'' k k' k'' Hlog Hlog'.
  simpl in Hlog, Hlog'.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2k & Hlog2kl & Hlog2kr).
  destruct Hlog' as (e1 & k1'' & e2 & k2'' & Heq & -> & Hlog1' & Hlog2' & Hlog2k' & Hlog2kl' & Hlog2kr').
  injection Heq; intros; subst e1 e2; clear Heq.
  simpl.
  #3 do 4 eexists; do2 6 split; eauto.
    eapply (IH1 ander andel); eauto; done.

    eapply (IH2 ander andel); eauto; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    #2 apply (IH2 andel _ _ _ (subst (dot d (sh i)) k2')).
      apply Hlog2k; auto; [].
      apply logc_symm; [].
      apply (IH1 ander ander _#4 (subst (sh i) k1)); eauto using logk_mono, logk_self_left, logc_self_left, logc_reg; done.

      apply Hlog2k'; auto; [].
      apply (IH1 ander ander _#4 (subst (sh i) k1)); eauto using logk_mono, logk_self_right, logc_self_left, logc_reg; done.

  intros D D' c c' l k k' Hlogk Hlog.
  simpl in Hlog, Hlogk.
  destruct Hlogk as (l1 & k1 & l2 & k2 & -> & -> & Hlogl1 & Hlogl2 & Hlogl2l & Hlogl2r).
  destruct Hlog as (e1 & k1' & e2 & k2' & Heq & -> & Hlog1 & Hlog2 & Hlog2k & Hlog2kl & Hlog2kr).
  injection Heq; clear Heq; intros; subst e1 e2.
  simpl.
  #3 do 4 eexists; do2 6 split; eauto.
    eapply (IH1 ander ander); eauto; done.

    apply (IH2 ander ander _#4 (subst1 (cn_pi1 c) l2)); auto; [].
    apply Hlogl2; auto with alg; [].
    simp_sub.
    apply logc_symm; [].
    apply (IH1 ander ander _#4 l1); auto; [].
    eapply logc_self_left; eauto; done.
  
    intros i D2 D2' d d' Hext Hext' Hlogd.
    #2 apply (IH2 andel _#3 (subst (dot d (sh i)) l2)).
      apply logk_symm; [].
      apply Hlogl2; auto; [].
      #2 apply (IH1 ander ander _#4 (subst (sh i) k1)).
        apply logk_symm; [].
        eapply logk_mono; eauto; done.
  
        eapply logc_self_left; eauto; done.
  
      apply Hlog2k; auto; [].
      eapply IH1; eauto; [].
      apply logk_symm; [].
      eapply logk_mono; eauto; done.

(* one *)
do2 2 split.
  intros D D' k k' k'' Hlog Hlog'.
  simpl in Hlog, Hlog'.
  destruct Hlog as (-> & ->).
  destruct Hlog' as (_ & ->).
  simpl.
  auto; done.

  intros D D' c c' c'' k k' k'' Hlog Hlog'.
  simpl in Hlog, Hlog'.
  destruct Hlog as (-> & ->).
  destruct Hlog' as (_ & ->).
  simpl.
  auto; done.

  intros D D' c c' l k k' Hlogk Hlog.
  simpl in Hlog, Hlogk.
  destruct Hlog as (-> & ->).
  destruct Hlogk as (_ & ->).
  simpl.
  auto; done.
Qed.


Lemma logc_adjust_left :
  forall sk D D' c c' l k k',
    logk sk D D l k
    -> logc sk D D' c c' l k'
    -> logc sk D D' c c' k k'.
Proof.
intro sk.
exact (log_trans_adjust sk ander ander).
Qed.


Lemma logc_adjust_right :
  forall sk D D' c c' l' k k',
    logk sk D' D' l' k'
    -> logc sk D D' c c' k l'
    -> logc sk D D' c c' k k'.
Proof.
intros sk D D' c c' k k' l' Hlogk Hlogc.
eauto using logc_symm, logc_adjust_left.
Qed.


Lemma logc_adjust :
  forall sk D D' c c' l l' k k',
    logk sk D D l k
    -> logk sk D' D' l' k'
    -> logc sk D D' c c' l l'
    -> logc sk D D' c c' k k'.
Proof.
intros sk D D' c c' l l' k k' Hlogk Hlogk' Hlog.
eapply logc_adjust_left; eauto; [].
eapply logc_adjust_right; eauto; done.
Qed.


Lemma logk_trans_left :
  forall sk D1 D3 k1 k2 k3,
    logk sk D1 D1 k1 k2
    -> logk sk D1 D3 k2 k3
    -> logk sk D1 D3 k1 k3.
Proof.
intro sk.
exact (log_trans_adjust sk andel).
Qed.


Lemma logk_trans_right :
  forall sk D1 D3 k1 k2 k3,
    logk sk D1 D3 k1 k2
    -> logk sk D3 D3 k2 k3
    -> logk sk D1 D3 k1 k3.
Proof.
intros.
apply logk_symm; [].
eapply logk_trans_left; eauto using logk_symm; done.
Qed.


Lemma logc_trans_left :
  forall sk D1 D3 c1 c2 c3 k1 k2 k3,
    logc sk D1 D1 c1 c2 k1 k2
    -> logc sk D1 D3 c2 c3 k2 k3
    -> logc sk D1 D3 c1 c3 k1 k3.
Proof.
intro sk.
exact (log_trans_adjust sk ander andel).
Qed.


Lemma logc_trans_right :
  forall sk D1 D3 c1 c2 c3 k1 k2 k3,
    logc sk D1 D3 c1 c2 k1 k2
    -> logc sk D3 D3 c2 c3 k2 k3
    -> logc sk D1 D3 c1 c3 k1 k3.
Proof.
intros.
apply logc_symm; [].
eapply logc_trans_left; eauto using logc_symm; done.
Qed.


Lemma logc_head_expand_left :
  forall sk D D' b c c' k k',
    logc sk D D' c c' k k'
    -> headred D b c
    -> logc sk D D' b c' k k'.
Proof.
intros sk.
induct sk.

(* type *)
intros D D' b c c' k k' Hlog Hred.
simpl in Hlog.
destruct Hlog as (-> & -> & Haeq).
invert Haeq.
intros p p' Hnorm Hnorm' Hpeq.
simpl.
do2 2 split; eauto with alg; done.

(* sing *)
intros D D' b c c' k k' Hlog Hred.
simpl in Hlog.
destruct Hlog as (d & d' & -> & -> & Haeqd & Haeqc & Haeq).
invert Haeqc.
intros p p' Hnormc Hnormc' Hpeqp.
invert Haeq.
intros q q' Hnormd Hnormcalt Hpeqq.
simpl.
do 2 eexists; do2 4 split; eauto with alg; done.

(* pi *)
intros sk1 IH1 sk2 IH2 D D' b c c' k k' Hlog Hred.
simpl in Hlog.
destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
simpl.
#2 do 4 eexists; do2 5 split; eauto.
  intros i D2 D2' d d' Hext Hext' Hlogd.
  eapply IH2; eauto; [].
  apply headred_app; [].
  eapply weaken_headred; eauto; done.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  #2 apply (IH2 _ _ _ (cn_app (subst (sh i) c) d)).
    apply logc_symm; [].
    #2 apply (IH2 _ _ _ (cn_app (subst (sh i) c) d')).
      apply logc_symm; eauto; done.

      apply headred_app; [].
      eapply weaken_headred; eauto; done.

    apply headred_app; [].
    eapply weaken_headred; eauto; done.
  
(* sigma *)
intros sk1 IH1 sk2 IH2 D D' b c c' k k' Hlog Hred.
simpl in Hlog.
destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlogk & Hlogkl & Hlogkr).
simpl.
#2 do 4 eexists; do2 6 split; eauto.
  eapply IH1; eauto with alg; done.
  #2 apply (logc_adjust_left _#5 (subst1 (cn_pi1 c) k2)).
    apply logk_symm; [].
    apply Hlogkl; auto with alg; [].
    simp_sub.
    eapply IH1; eauto using logc_self_left, headred_pi1; done.
  
    eapply IH2; eauto using headred_pi2; done.

(* one *)
intros D D' b c c' k k' Hlog Hred.
simpl in Hlog.
destruct Hlog as (-> & ->).
simpl.
auto; done.
Qed.


Lemma logc_head_expand :
  forall sk D D' b b' c c' k k',
    logc sk D D' c c' k k'
    -> headred D b c
    -> headred D' b' c'
    -> logc sk D D' b b' k k'.
Proof.
intros sk D D' b b' c c' k k' Hlog Hred Hred'.
eapply logc_head_expand_left; eauto; [].
apply logc_symm; [].
eapply logc_head_expand_left; eauto; [].
apply logc_symm; eauto; done.
Qed.


Lemma main_lemma :
  forall sk,
    (forall D D' k k',
       logk sk D D' k k'
       -> aeqk D D' k k')
    /\
    (forall D D' c c' k k',
       logc sk D D' c c' k k'
       -> aeq D D' c c' k k')
    /\
    (forall D D' p p' k k',
       path p
       -> path p'
       -> peq D D' p p' k k'
       -> logk sk D D' k k'
       -> logc sk D D' p p' k k').
Proof.
intro sk.
induct sk.

(* type *)
do2 2 split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  auto with alg; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & -> & Haeq).
  assumption.

  intros D D' p p' k k' Hpath Hpath' Hpeq Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  simpl.
  do2 2 split; auto; [].
  so (peq_natk _#6 Hpeq) as (Hnatk & Hnatk').
  apply (@aeq_type _#4 p p'); auto with alg; done.

(* sing *)
do2 2 split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (b & b' & -> & -> & Haeq).
  auto with alg; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (b & b' & -> & -> & _).
  auto with alg; done.

  intros D D' p p' k k' Hpath Hpath' Hpeq Hlog.
  destruct Hlog as (b & b' & -> & -> & Haeq).
  invert Haeq; [].
  intros q q' Hnormb Hnormb' Hpeqq.
  assert (headnorm D p q) as Hnormp.
    eapply headnorm_more; eauto; [].
    apply headred_sing; [].
    refine (peq_natk _#7 andel); eauto; done.
  assert (headnorm D' p' q') as Hnormp'.
    eapply headnorm_more; eauto; [].
    apply headred_sing; [].
    refine (peq_natk _#7 ander); eauto; done.
  simpl.
  exists b, b'.
  do2 4 split; eauto with alg; [].
  apply (@aeq_type _#4 q q); eauto using peq_symm, peq_trans; done.

(* pi *)
intros sk1 IH1 sk2 IH2.
do2 2 split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & _).
  #2 apply aeqk_pi.
    apply (IH1 andel); auto; done.

    apply (IH2 andel); auto; [].
    rewrite <- (subst_dot0_sh k2).
    rewrite <- (subst_dot0_sh k2').
    apply Hlog2; auto using extend_1; [].
    apply (IH1 ander ander); eauto with alg sequence; [].
    eapply logk_mono; eauto using extend_1; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & _).
  apply aeq_pi; [].
  apply IH2; [].
  rewrite <- (subst_dot0_sh k2).
  rewrite <- (subst_dot0_sh k2').
  apply Hlog2; auto using extend_1; [].
  apply (IH1 ander ander); eauto with alg sequence; [].
  eapply log_mono; eauto using extend_1; done.

  intros D D' p p' k k' Hpath Hpath' Hpeq Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  simpl.
  exists k1, k1', k2, k2'.
  #3 do2 5 split; auto.
    intros i D2 D2' d d' Hext Hext' Hlogd.
    apply (IH2 ander ander); auto using shift_path with alg; [].
    rewrite -> 2 (split_dot _ (sh i)).
    rewrite -> 2 subst_compose.
    #2 apply (@peq_app _#6 (subst (sh i) k1) (subst (sh i) k1')).
      so (weaken_peq _#9 Hext Hext' Hpeq) as Hpeq'.
      simp_sub in Hpeq'.
      simp_sub.
      assumption.
  
      apply (IH1 ander andel); auto; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    apply (IH2 ander ander); auto using shift_path with alg; [].
    rewrite -> 2 (split_dot _ (sh i)).
    rewrite -> 2 subst_compose.
    #2 apply (@peq_app _#6 (subst (sh i) k1) (subst (sh i) k1)).
      so (weaken_peq _#9 Hext Hext' (peq_self_left _#6 Hpeq)) as Hpeq'.
      simp_sub in Hpeq'.
      simp_sub.
      assumption.

      apply (IH1 ander andel); auto; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    apply (IH2 ander ander); auto using shift_path with alg; [].
    rewrite -> 2 (split_dot _ (sh i)).
    rewrite -> 2 subst_compose.
    #2 apply (@peq_app _#6 (subst (sh i) k1') (subst (sh i) k1')).
      so (weaken_peq _#9 Hext Hext' (peq_self_right _#6 Hpeq)) as Hpeq'.
      simp_sub in Hpeq'.
      simp_sub.
      assumption.
  
      apply (IH1 ander andel); auto; done.

(* sigma *)
intros sk1 IH1 sk2 IH2.
do2 2 split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & _).
  #2 apply aeqk_sigma.
    apply (IH1 andel); auto; done.

    apply (IH2 andel); auto; [].
    rewrite <- (subst_dot0_sh k2).
    rewrite <- (subst_dot0_sh k2').
    apply Hlog2; auto using extend_1; [].
    apply (IH1 ander ander); eauto with alg sequence; [].
    eapply logk_mono; eauto using extend_1; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & _).
  #2 apply aeq_sigma; auto.
    apply (IH1 ander andel); auto; done.

    apply (IH2 ander andel); auto; done.

  intros D D' p p' k k' Hpath Hpath' Hpeq Hlog.
  simpl in Hlog.
  destruct Hlog as (k1 & k1' & k2 & k2' & -> & -> & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  simpl.
  exists k1, k1', k2, k2'.
  #2 do2 6 split; auto.
    apply (IH1 ander ander); eauto with alg; done.

    apply (IH2 ander ander); eauto with alg; [].
    apply Hlog2; auto using extend_0; [].
    simp_sub.
    apply (IH1 ander ander); eauto with alg; done.

(* one *)
do2 2 split.
  intros D D' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  apply aeqk_one; done.

  intros D D' c c' k k' Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  apply aeq_one; done.

  intros D D' p p' k k' Hpath Hpath' Hpeq Hlog.
  simpl in Hlog.
  destruct Hlog as (-> & ->).
  simpl.
  auto; done.
Qed.


Definition logsk sk sk' D D' k k' l l' :=
  forall i D2 D2' c c',
    extend i D D2
    -> extend i D' D2'
    -> logc sk D2 D2' c c' (subst (sh i) k) (subst (sh i) k')
    -> logc sk' D2 D2' c c' (subst (sh i) l) (subst (sh i) l').


Inductive logsub : context -> context -> sub -> sub -> context -> Prop :=
| logsub_nil {D D' i}
    : logsub D D' (sh i) (sh i) nil

| logsub_cons {D D' c c' s s' G k}
    : logsub D D' s s' G
      -> logc (skel k) D D' c c' (subst s k) (subst s' k)
      -> logsub D D' (dot c s) (dot c' s') (G; cl_cn k)

| logsub_tm {D D' e e' s s' G t}
    : logsub D D' s s' G
      -> logsub D D' (dot e s) (dot e' s') (G; cl_tm t)

| logsub_md {D D' m m' s s' G S c}
    : logsub D D' s s' G
      -> logsub D D' (dot m s) (dot m' s') (G; cl_md S c)
.


Lemma logsub_mono :
  forall i D D' D2 D2' s s' G,
    extend i D D2
    -> extend i D' D2'
    -> logsub D D' s s' G
    -> logsub D2 D2' (compose s (sh i)) (compose s' (sh i)) G.
Proof.
intros i D D' D2 D2' s s' G Hext Hext' Hlogsub.
revert Hext Hext'.
induct Hlogsub.

(* nil *)
intros.
simp_sub.
apply logsub_nil; done.

(* cons *)
intros D D' c c' s s' G k _ IH Hlog Hext Hext'.
simp_sub.
apply logsub_cons; auto; [].
rewrite -> !subst_compose.
eapply logc_mono; eauto; done.

(* tm *)
intros D D' e e' s s' G t _ IH Hext Hext'.
apply logsub_tm; auto; done.

(* md *)
intros D D' m m' s s' G S c _ IH Hext Hext'.
apply logsub_md; auto; done.
Qed.


Lemma logsub_symm :
  forall D D' s s' G,
    logsub D D' s s' G
    -> logsub D' D s' s G.
Proof.
intros D D' s s' G Hlog.
induct Hlog.

(* nil *)
intros.
apply logsub_nil; done.

(* cons *)
intros D D' c c' s s' G k _ IH Hlog.
apply logsub_cons; auto; [].
apply logc_symm; auto; done.

(* tm *)
intros D D' e e' s s' G t _ IH.
apply logsub_tm; auto; done.

(* md *)
intros D D' m m' s s' G S c _ IH.
apply logsub_md; auto; done.
Qed.


Lemma logsub_self_left :
  forall D D' s s' G,
    logsub D D' s s' G
    -> logsub D D s s G.
Proof.
intros D D' s s' G Hlogsub.
induct Hlogsub.

(* nil *)
intros; apply logsub_nil; done.

(* cons *)
intros D D' c c' s s' G k _ IH Hlog.
apply logsub_cons; auto; [].
eapply logc_self_left; eauto; done.

(* tm *)
intros D D' e e' s s' G t _ IH.
apply logsub_tm; auto; done.

(* md *)
intros D D' m m' s s' G S c _ IH.
apply logsub_md; auto; done.
Qed.


Lemma logsub_self_right :
  forall D D' s s' G,
    logsub D D' s s' G
    -> logsub D' D' s' s' G.
Proof.
intros.
eapply logsub_self_left; [].
apply logsub_symm; eauto; done.
Qed.


Lemma logk_diag_left :
  forall sk G k k',
    (forall D D' s s', logsub D D' s s' G -> logk sk D D' (subst s k) (subst s' k'))
    -> (forall D D' s s', logsub D D' s s' G -> logk sk D D' (subst s k) (subst s' k)).
Proof.
intros sk G k k' Himp D D' s s' Hlog.
#2 apply (logk_trans_left _#4 (subst s k')).
  apply Himp; [].
  eapply logsub_self_left; eauto; done.

  apply logk_symm; [].
  apply Himp; [].
  apply logsub_symm; auto; done.
Qed.


Lemma logk_diag_right :
  forall sk G k k',
    (forall D D' s s', logsub D D' s s' G -> logk sk D D' (subst s k) (subst s' k'))
    -> (forall D D' s s', logsub D D' s s' G -> logk sk D D' (subst s k') (subst s' k')).
Proof.
intros sk G k k' Himp D D' s s' Hlog.
apply (logk_diag_left sk G _ k); auto; [].
clear D D' s s' Hlog.
intros D D' s s' Hlog.
apply logk_symm; [].
apply Himp; [].
apply logsub_symm; auto; done.
Qed.


Lemma logc_diag_left :
  forall sk G c c' k k',
    (forall D D' s s', logsub D D' s s' G -> logc sk D D' (subst s c) (subst s' c') (subst s k) (subst s' k'))
    -> (forall D D' s s', logsub D D' s s' G -> logc sk D D' (subst s c) (subst s' c) (subst s k) (subst s' k)).
Proof.
intros sk G c c' k k' Himp D D' s s' Hlog.
#2 apply (logc_trans_left _#4 (subst s c') _ _ (subst s k')).
  apply Himp; [].
  eapply logsub_self_left; eauto; done.

  apply logc_symm; [].
  apply Himp; [].
  apply logsub_symm; auto; done.
Qed.


Lemma logc_diag_right :
  forall sk G c c' k k',
    (forall D D' s s', logsub D D' s s' G -> logc sk D D' (subst s c) (subst s' c') (subst s k) (subst s' k'))
    -> (forall D D' s s', logsub D D' s s' G -> logc sk D D' (subst s c') (subst s' c') (subst s k') (subst s' k')).
Proof.
intros sk G c c' k k' Himp D D' s s' Hlog.
apply (logc_diag_left sk G _ c _ k); auto; [].
clear D D' s s' Hlog.
intros D D' s s' Hlog.
apply logc_symm; [].
apply Himp; [].
apply logsub_symm; auto; done.
Qed.


Definition rotate5 {A B C D E : Type} {F : forall (a:A) (b:B) (c:C) (d:D) (e:E), Type} (f : forall a b c d e, F a b c d e) :=
  fun e a b c d => f a b c d e.


(* We oughtn't need the (wf G) premises.  We need them because of our weak
   treatment of syntax: without them, we cannot prove that k is actually a kind,
   and therefore that skel k = skel (subst s k).  We could get by with a weaker
   premise (e.g. everything in G is syntactically well-formed), but once we've
   got the plumbing in, it seems best just to use the type theory.
*)
Lemma fundamental_theorem :
  (forall G k D D' s s',
     ofk G k
     -> wf G
     -> logsub D D' s s' G
     -> logk (skel k) D D' (subst s k) (subst s' k))
  /\
  (forall G k k' D D' s s',
     eqk G k k'
     -> wf G
     -> logsub D D' s s' G
     -> logk (skel k) D D' (subst s k) (subst s' k'))
  /\
  (forall G k k' D D' s s',
     subk G k k'
     -> wf G
     -> logsub D D' s s' G
     -> logk (skel k) D D' (subst s k) (subst s' k)
        /\ logk (skel k') D D' (subst s k') (subst s' k')
        /\ (forall c c',
              logc (skel k) D D' c c' (subst s k) (subst s' k)
              -> logc (skel k') D D' c c' (subst s k') (subst s' k')))
  /\
  (forall G c k D D' s s',
     ofc G c k
     -> wf G
     -> logsub D D' s s' G
     -> logc (skel k) D D' (subst s c) (subst s' c) (subst s k) (subst s' k))
  /\
  (forall G c c' k D D' s s',
     eqc G c c' k
     -> wf G
     -> logsub D D' s s' G
     -> logc (skel k) D D' (subst s c) (subst s' c') (subst s k) (subst s' k)).
Proof.
exploit
  (static_ind
     (fun G k =>
        forall D D' s s',
          wf G
          -> logsub D D' s s' G
          -> logk (skel k) D D' (subst s k) (subst s' k))
     (fun G k k' =>
        forall D D' s s',
          wf G
          -> logsub D D' s s' G
          -> logk (skel k) D D' (subst s k) (subst s' k'))
     (fun G k k' =>
        forall D D' s s',
          wf G
          -> logsub D D' s s' G
          -> logk (skel k) D D' (subst s k) (subst s' k)
             /\ logk (skel k') D D' (subst s k') (subst s' k')
             /\ (forall c c',
                   logc (skel k) D D' c c' (subst s k) (subst s' k)
                   -> logc (skel k') D D' c c' (subst s k') (subst s' k')))
     (fun G c k =>
        forall D D' s s',
          wf G
          -> logsub D D' s s' G
          -> logc (skel k) D D' (subst s c) (subst s' c) (subst s k) (subst s' k))
     (fun G c c' k =>
        forall D D' s s',
          wf G
          -> logsub D D' s s' G
          -> logc (skel k) D D' (subst s c) (subst s' c') (subst s k) (subst s' k))) as Hind.

(* type *)
intros G D D' s s' _ Hlogs.
simp_sub.
simpl.
auto; done.

(* sing *)
intros G c _ IH D D' s s' Hwf Hlogs.
simpl.
exists (subst s c), (subst s' c).
do2 2 split; auto; [].
apply (main_lemma sk_type ander andel).
so (IH _#4 Hwf Hlogs) as Hlog.
simp_sub in Hlog.
assumption.

(* pi *)
intros G k1 k2 Hofk1 IH1 _ IH2 D D' s s' Hwf Hlogs.
simpl.
#3 do 4 eexists; do2 5 split; simp_sub; eauto.
  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH2; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; done.

    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH2; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_left; eauto; done.

    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH2; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_right; eauto; done.

    assumption.

(* sigma *)
intros G k1 k2 Hofk1 IH1 _ IH2 D D' s s' Hwf Hlogs.
simpl.
#3 do 4 eexists; do2 5 split; simp_sub; eauto.
  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH2; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; done.

    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH2; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_left; eauto; done.

    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH2; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_right; eauto; done.

    assumption.

(* one *)
intros G D D' s s' _ Hlogs.
simpl.
auto; done.

(* refl *)
intros G k _ IH D D' s s' Hwf Hlogs.
apply IH; auto; done.

(* symm *)
intros G k k' Heqk IH D D' s s' Hwf Hlogs.
rewrite <- (eqk_skel _#3 Heqk).
apply logk_symm; [].
apply IH; auto; [].
apply logsub_symm; auto; done.

(* trans *)
intros G k1 k2 k3 Heqk1 IH1 Heqk2 IH2 D D' s s' Hwf Hlogs.
#2 apply (logk_trans_left _#4 (subst s k2)).
  apply IH1; auto; [].
  eapply logsub_self_left; eauto; done.

  rewrite -> (eqk_skel _#3 Heqk1).
  apply IH2; auto; done.

(* sing *)
intros G c c' _ IH D D' s s' Hwf Hlogs.
simpl.
exists (subst s c), (subst s' c').
do2 2 split; auto; [].
so (IH _#4 Hwf Hlogs) as Hlog.
simpl in Hlog.
destruct Hlog as (_ & _ & ?).
assumption.

(* pi *)
intros G k1 k1' k2 k2' Heqk1 IH1 _ IH2 D D' s s' Hwf Hlogs.
so (eqk_reg _#3 Hwf Heqk1) as (Hofk1 & _).
simpl.
#3 do 4 eexists; do2 5 split; simp_sub; eauto.
  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub.
  apply IH2; auto using wf_cn; [].
  apply logsub_cons; eauto using logsub_mono; [].
  simp_sub in Hlogd.
  apply (logc_adjust_right _#5 (subst (compose s' (sh i)) k1')); auto; [].
  apply logk_symm; [].
  apply IH1; auto; [].
  apply (logsub_self_right D2 _ (compose s (sh i))); [].
  eapply logsub_mono; eauto; done.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply (logk_diag_left _#4 (rotate5 IH2 (wf_cn Hwf Hofk1))); [].
  apply logsub_cons; auto; [].
  eapply logsub_mono; eauto using logsub_self_left; done.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  assert (logk (skel k1) D2 D2 (subst (compose s' (sh i)) k1') (subst (compose s' (sh i)) k1)) as Hlogk1.
    apply logk_symm; [].
    apply IH1; eauto using logsub_mono, logsub_self_right; done.
  apply (logk_diag_right _#4 (rotate5 IH2 (wf_cn Hwf Hofk1))); [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_right; eauto; done.
    
    eapply (logc_adjust _#6 (subst (compose s' (sh i)) k1')); eauto; [].
    apply logk_symm; [].
    apply IH1; eauto using logsub_mono, logsub_self_right; done.

(* sigma *)
intros G k1 k1' k2 k2' Heqk1 IH1 _ IH2 D D' s s' Hwf Hlogs.
so (eqk_reg _#3 Hwf Heqk1) as (Hofk1 & _).
simpl.
#3 do 4 eexists; do2 5 split; simp_sub; eauto.
  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub.
  apply IH2; auto using wf_cn; [].
  apply logsub_cons; eauto using logsub_mono; [].
  simp_sub in Hlogd.
  apply (logc_adjust_right _#5 (subst (compose s' (sh i)) k1')); auto; [].
  apply logk_symm; [].
  apply IH1; auto; [].
  apply (logsub_self_right D2 _ (compose s (sh i))); [].
  eapply logsub_mono; eauto; done.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply (logk_diag_left _#4 (rotate5 IH2 (wf_cn Hwf Hofk1))); [].
  apply logsub_cons; auto; [].
  eapply logsub_mono; eauto using logsub_self_left; done.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  assert (logk (skel k1) D2 D2 (subst (compose s' (sh i)) k1') (subst (compose s' (sh i)) k1)) as Hlogk1.
    apply logk_symm; [].
    apply IH1; eauto using logsub_mono, logsub_self_right; done.
  apply (logk_diag_right _#4 (rotate5 IH2 (wf_cn Hwf Hofk1))); [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_right; eauto; done.
    
    eapply (logc_adjust _#6 (subst (compose s' (sh i)) k1')); eauto; [].
    apply logk_symm; [].
    apply IH1; eauto using logsub_mono, logsub_self_right; done.

(* refl *)
intros G k k' Heqk IH D D' s s' Hwf Hlogs.
do2 2 split.
  apply (logk_diag_left _#4 (rotate5 IH Hwf)); auto; done.

  rewrite <- (eqk_skel _#3 Heqk); [].
  apply (logk_diag_right _#4 (rotate5 IH Hwf)); auto; done.

  intros c c' Hlog.
  rewrite <- (eqk_skel _#3 Heqk); [].
  #2 apply (logc_adjust _#5 (subst s k) (subst s' k)); auto.
    apply IH; auto; [].
    eapply logsub_self_left; eauto; done.
  
    apply IH; auto; [].
    eapply logsub_self_right; eauto; done.

(* trans *)
intros G k1 k2 k3 _ IH1 _ IH2 D D' s s' Hwf Hlogs.
do2 2 split.
  refine (IH1 _#6 andel); eauto; done.

  refine (IH2 _#6 ander andel); eauto; done.

  intros c c' Hlog.
  apply IH2; auto; [].
  apply IH1; auto; done.

(* sing_t *)
intros G b _ IH D D' s s' Hwf Hlogs.
do2 2 split.
  simpl.
  do 2 eexists; do2 2 split; simp_sub; eauto; [].
  so (IH D D' s s' Hwf Hlogs) as Hlog.
  simpl in Hlog.
  destruct Hlog as (_ & _ & ?).
  assumption.

  simp_sub.
  simpl.
  auto; done.

  intros c c' Hlog.
  simpl in Hlog.
  destruct Hlog as (e & e' & Heq & Heq' & _ & Haeq & _).
  simp_sub in Heq; injection Heq; clear Heq; intros; subst e.
  simp_sub in Heq'; injection Heq'; clear Heq'; intros; subst e'.
  simpl.
  auto; done.  

(* pi *)
intros G k1 k1' k2 k2' Hsubk IH1 _ IH2 _ IH3 D D' s s' Hwf Hlogs.
so (subk_reg _#3 Hwf Hsubk) as (Hofk1' & Hofk1).
do2 2 split.
  simp_sub.
  simpl.
  #4 do 4 eexists; do2 5 split; eauto.
    refine (IH1 _#6 ander andel); eauto; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply IH3; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply IH3; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono, logsub_self_left; done.
    
    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply IH3; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono, logsub_self_right; done.

  simp_sub.
  simpl.
  #4 do 4 eexists; do2 5 split; eauto.
    refine (IH1 _#6 andel); eauto; done.
    
    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    refine (IH2 _#6 ander andel); auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    refine (IH2 _#6 ander andel); auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono, logsub_self_left; done.
    
    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    refine (IH2 _#6 ander andel); auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono, logsub_self_right; done.

  intros c c' Hlog.
  simpl in Hlog.
  destruct Hlog as (e1 & e1' & e2 & e2' & Heq & Heq' & Hlog1 & Hlog2 & Hlog2l & Hlog2r).
  simp_sub in Heq; injection Heq; clear Heq; intros; subst e1 e2.
  simp_sub in Heq'; injection Heq'; clear Heq'; intros; subst e1' e2'.
  simp_sub.
  simpl.
  #4 do 4 eexists; do2 5 split; simp_sub; eauto.
    refine (IH1 _#6 andel); auto; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    #2 apply IH2; auto using wf_cn.
      apply logsub_cons; eauto using logsub_mono; done.

      #2 exploit (Hlog2 i D2 D2' d d') as Hlogapp; auto.
        simp_sub.
        apply IH1; eauto using logsub_mono; done.

        simp_sub in Hlogapp.
        assumption.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    #2 apply IH2; auto using wf_cn.
      apply logsub_cons; eauto using logsub_mono, logsub_self_left; done.

      #2 exploit (Hlog2l i D2 D2' d d') as Hlogapp; auto.
        simp_sub.
        apply IH1; eauto using logsub_mono, logsub_self_left; done.

        simp_sub in Hlogapp.
        assumption.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    #2 apply IH2; auto using wf_cn.
      apply logsub_cons; eauto using logsub_mono, logsub_self_right; done.

      #2 exploit (Hlog2r i D2 D2' d d') as Hlogapp; auto.
        simp_sub.
        apply IH1; eauto using logsub_mono, logsub_self_right; done.

        simp_sub in Hlogapp.
        assumption.

(* sigma *)
intros G k1 k1' k2 k2' Hsubk IH1 _ IH2 _ IH3 D D' s s' Hwf Hlogs.
so (subk_reg _#3 Hwf Hsubk) as (Hofk1 & Hofk1').
do2 2 split.
  simp_sub.
  simpl.
  #4 do 4 eexists; do2 5 split; eauto.
    refine (IH1 _#6 andel); eauto; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    refine (IH2 _#6 andel); auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    refine (IH2 _#6 andel); auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono, logsub_self_left; done.
    
    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    refine (IH2 _#6 andel); auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono, logsub_self_right; done.

  simp_sub.
  simpl.
  #4 do 4 eexists; do2 5 split; eauto.
    refine (IH1 _#6 ander andel); eauto; done.
    
    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply IH3; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono; done.

    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply IH3; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono, logsub_self_left; done.
    
    intros i D2 D2' d d' Hext Hext' Hlogd.
    simp_sub in Hlogd.
    simp_sub.
    apply IH3; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono, logsub_self_right; done.

  intros c c' Hlog.
  simpl in Hlog.
  destruct Hlog as (e1 & e1' & e2 & e2' & Heq & Heq' & Hlog1 & Hlog2 & Hlog2k & Hlog2kl & Hlog2kr).
  simp_sub in Heq; injection Heq; clear Heq; intros; subst e1 e2.
  simp_sub in Heq'; injection Heq'; clear Heq'; intros; subst e1' e2'.
  simp_sub.
  simpl.
  #5 do 4 eexists; do2 6 split; simp_sub; eauto.
    apply IH1; auto; done.

    simp_sub.
    #2 apply IH2; auto using wf_cn.
      apply logsub_cons; auto; done.

      simp_sub in Hlog2.
      assumption.

      intros i D2 D2' d d' Hext Hext' Hlogd.
      simp_sub in Hlogd.
      simp_sub.
      apply IH3; auto using wf_cn; [].
      apply logsub_cons; eauto using logsub_mono; done.

      intros i D2 D2' d d' Hext Hext' Hlogd.
      simp_sub in Hlogd.
      simp_sub.
      apply IH3; auto using wf_cn; [].
      apply logsub_cons; eauto using logsub_mono, logsub_self_left; done.

      intros i D2 D2' d d' Hext Hext' Hlogd.
      simp_sub in Hlogd.
      simp_sub.
      apply IH3; auto using wf_cn; [].
      apply logsub_cons; eauto using logsub_mono, logsub_self_right; done.

(* var *)
intros G i k Hindex D D' s s' _ Hlogs.
simp_sub.
remember (cl_cn k) as cl eqn:Heqcl.
revert s s' Heqcl Hlogs.
#2 induct Hindex.
  (* 0 *)
  intros cl G s s' -> Hlogs.
  invert Hlogs; [].
  intros c c' t t' Hlogs' Hlogc <- <-.
  simp_sub.
  rewrite -> shift_skel; [].
  assumption.

  (* S *)
  intros i cl G cl' _ IH s s' -> Hlogs.
  assert (exists x x' t t', logsub D D' t t' G /\ s = dot x t /\ s' = dot x' t') as (x & x' & t & t' & Hlogs' & -> & ->).
    invert Hlogs; intros; do 4 eexists; do2 2 split; eauto; done.
  simp_sub.
  so (IH _ _ (eq_refl _) Hlogs') as Hlog.
  rewrite -> shift_skel.
  rewrite -> shift_skel in Hlog.
  assumption.

(* lam *)
intros G k1 k2 c Hofk1 IH1 _ IH2 D D' s s' Hwf Hlogs.
simp_sub.
simpl.
#3 do 4 eexists; do2 5 split; eauto.
  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  #3 apply (logc_head_expand _#5 (subst (dot d (compose s (sh i))) c) (subst (dot d' (compose s' (sh i))) c)).
    apply IH2; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono; done.

    so (@headred_beta D2 (subst (compose s (sh i)) k1) (subst (dot (var 0) (compose s (sh (S i)))) c) d) as Hred.
    simp_sub in Hred.
    assumption.

    so (@headred_beta D2' (subst (compose s' (sh i)) k1) (subst (dot (var 0) (compose s' (sh (S i)))) c) d') as Hred.
    simp_sub in Hred.
    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  #3 apply (logc_head_expand _#5 (subst (dot d (compose s (sh i))) c) (subst (dot d' (compose s (sh i))) c)).
    apply IH2; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono, logsub_self_left; done.

    so (@headred_beta D2 (subst (compose s (sh i)) k1) (subst (dot (var 0) (compose s (sh (S i)))) c) d) as Hred.
    simp_sub in Hred.
    assumption.

    so (@headred_beta D2' (subst (compose s (sh i)) k1) (subst (dot (var 0) (compose s (sh (S i)))) c) d') as Hred.
    simp_sub in Hred.
    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  #3 apply (logc_head_expand _#5 (subst (dot d (compose s' (sh i))) c) (subst (dot d' (compose s' (sh i))) c)).
    apply IH2; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono, logsub_self_right; done.

    so (@headred_beta D2 (subst (compose s' (sh i)) k1) (subst (dot (var 0) (compose s' (sh (S i)))) c) d) as Hred.
    simp_sub in Hred.
    assumption.

    so (@headred_beta D2' (subst (compose s' (sh i)) k1) (subst (dot (var 0) (compose s' (sh (S i)))) c) d') as Hred.
    simp_sub in Hred.
    assumption.

(* app *)
intros G k1 k2 c1 c2 Hofc IH1 _ IH2 D D' s s' Hwf Hlogs.
so (IH1 _#4 Hwf Hlogs) as Hlogfn.
so (IH2 _#4 Hwf Hlogs) as Hlogarg.
simp_sub in Hlogfn.
simpl in Hlogfn.
destruct Hlogfn as (e1 & e1' & e2 & e2' & Heq & Heq' & Hlog1 & Hlog2 & _).
injection Heq; clear Heq; intros; subst e1 e2.
injection Heq'; clear Heq'; intros; subst e1' e2'.
#2 exploit (Hlog2 0 D D' (subst s c2) (subst s' c2)) as Hlogapp; auto with alg.
  simp_sub; assumption.
simp_sub in Hlogapp.
simp_sub.
so (ofk_hkd _ _ (ofc_reg _#3 Hwf Hofc)) as Hhkd.
invert Hhkd.
intros _ Hhkd2.
unfold subst1.
rewrite -> (subst_skel (dot c2 id) _ Hhkd2); [].
assumption.  

(* pair *)
intros G k1 k2 c1 c2 Hofc1 IH1 _ IH2 Hofk2 IH3 D D' s s' Hwf Hlogs.
so (ofc_reg _#3 Hwf Hofc1) as Hofk1.
so (ofk_hkd _ _ Hofk2) as Hhkd.
simp_sub.
simpl.
#5 do 4 eexists; do2 6 split; eauto.
  apply (logc_head_expand _#5 (subst s c1) (subst s' c1)); auto with alg; done.

  simp_sub.
  apply (logc_head_expand _#5 (subst s c2) (subst s' c2)); auto with alg; [].
  #3 apply (logc_adjust _#5 (subst (dot (subst s c1) s) k2) (subst (dot (subst s' c1) s') k2)).
    apply logk_symm; [].
    apply IH3; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_self_left; [].
    apply (logc_head_expand_left _#4 (subst s c1)); auto with alg; [].
    apply IH1; eauto using logsub_self_left; done.

    apply logk_symm; [].
    apply IH3; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_self_right; [].
    apply (logc_head_expand_left _#4 (subst s' c1)); auto with alg; [].
    apply IH1; eauto using logsub_self_right; done.

    exploit (IH2 D D' s s') as Hlogpi2; auto; [].
    simp_sub in Hlogpi2.
    unfold subst1 in Hlogpi2.
    rewrite -> (subst_skel _ _ Hhkd) in Hlogpi2; [].
    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH3; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; done.

    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH3; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_left; eauto; done.

    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH3; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_right; eauto; done.

    assumption.

(* pi1 *)
intros G k1 k2 c _ IH D D' s s' Hwf Hlogs.
simp_sub.
so (IH _#4 Hwf Hlogs) as Hlog.
simp_sub in Hlog.
simpl in Hlog.
destruct Hlog as (e1 & e1' & e2 & e2' & Heq & Heq' & Hlog1 & Hlog2 & _).
injection Heq; clear Heq; intros; subst e1 e2.
injection Heq'; clear Heq'; intros; subst e1' e2'.
assumption.

(* pi2 *)
intros G k1 k2 c Hofc IH D D' s s' Hwf Hlogs.
simp_sub.
so (IH _#4 Hwf Hlogs) as Hlog.
simp_sub in Hlog.
simpl in Hlog.
destruct Hlog as (e1 & e1' & e2 & e2' & Heq & Heq' & Hlog1 & Hlog2 & _).
injection Heq; clear Heq; intros; subst e1 e2.
injection Heq'; clear Heq'; intros; subst e1' e2'.
simp_sub in Hlog2.
so (ofk_hkd _ _ (ofc_reg _#3 Hwf Hofc)) as Hhkd.
invert Hhkd.
intros _ Hhkd2.
unfold subst1.
rewrite -> (subst_skel _ _ Hhkd2); [].
assumption.

(* one *)
intros G D D' s s' _ _.
simpl.
auto; done.

(* unit *)
intros G D D' s s' _ _.
simp_sub.
simpl.
do2 2 split; auto; [].
apply (@aeq_type _#4 cn_unit cn_unit); auto with alg; done.

(* arrow *)
intros G t1 t2 _ IH1 _ IH2 D D' s s' Hwf Hlogs.
simp_sub.
simpl.
do2 2 split; auto; [].
apply (@aeq_type _#4 (cn_arrow (subst s t1) (subst s t2)) (cn_arrow (subst s' t1) (subst s' t2))); auto with alg; [].
#2 apply peq_arrow.
  so (IH1 _#4 Hwf Hlogs) as Hlog.
  simpl in Hlog.
  destruct Hlog as (_ & _ & Haeq).
  assumption.

  so (IH2 _#4 Hwf Hlogs) as Hlog.
  simpl in Hlog.
  destruct Hlog as (_ & _ & Haeq).
  assumption.

(* prod *)
intros G t1 t2 _ IH1 _ IH2 D D' s s' Hwf Hlogs.
simp_sub.
simpl.
do2 2 split; auto; [].
apply (@aeq_type _#4 (cn_prod (subst s t1) (subst s t2)) (cn_prod (subst s' t1) (subst s' t2))); auto with alg; [].
#2 apply peq_prod.
  so (IH1 _#4 Hwf Hlogs) as Hlog.
  simpl in Hlog.
  destruct Hlog as (_ & _ & Haeq).
  assumption.

  so (IH2 _#4 Hwf Hlogs) as Hlog.
  simpl in Hlog.
  destruct Hlog as (_ & _ & Haeq).
  assumption.

(* all *)
intros G k t Hofk IH1 _ IH2 D D' s s' Hwf Hlogs.
simp_sub.
simpl.
do2 2 split; auto; [].
apply (@aeq_type _#4 (cn_all (subst s k) (subst (dot (var 0) (compose s sh1)) t)) (cn_all (subst s' k) (subst (dot (var 0) (compose s' sh1)) t))); auto with alg; [].
#2 apply peq_all.
  apply (main_lemma (skel k) andel); [].
  apply IH1; auto; done.

  #2 exploit (IH2 (D; cl_cn (subst s k)) (D'; cl_cn (subst s' k)) (dot (var 0) (compose s sh1)) (dot (var 0) (compose s' sh1))) as Hlog; auto using wf_cn.
    #2 apply logsub_cons.
      eapply logsub_mono; eauto using extend_1; done.

      #2 apply (main_lemma (skel k) ander ander); auto with alg.
        rewrite -> !subst_compose.
        apply peq_var; auto using index_0; done.

        apply IH1; auto; [].
        eapply logsub_mono; eauto using extend_1; done.

    simp_sub in Hlog.
    destruct Hlog as (_ & _ & Haeq).
    assumption.

(* exists *)
intros G k t Hofk IH1 _ IH2 D D' s s' Hwf Hlogs.
simp_sub.
simpl.
do2 2 split; auto; [].
apply (@aeq_type _#4 (cn_exists (subst s k) (subst (dot (var 0) (compose s sh1)) t)) (cn_exists (subst s' k) (subst (dot (var 0) (compose s' sh1)) t))); auto with alg; [].
#2 apply peq_exists.
  apply (main_lemma (skel k) andel); [].
  apply IH1; auto; done.

  #2 exploit (IH2 (D; cl_cn (subst s k)) (D'; cl_cn (subst s' k)) (dot (var 0) (compose s sh1)) (dot (var 0) (compose s' sh1))) as Hlog; auto using wf_cn.
    #2 apply logsub_cons.
      eapply logsub_mono; eauto using extend_1; done.

      #2 apply (main_lemma (skel k) ander ander); auto with alg.
        rewrite -> !subst_compose.
        apply peq_var; auto using index_0; done.

        apply IH1; auto; [].
        eapply logsub_mono; eauto using extend_1; done.

    simp_sub in Hlog.
    destruct Hlog as (_ & _ & Haeq).
    assumption.

(* sing *)
intros G c _ IH D D' s s' Hwf Hlogs.
so (IH _#4 Hwf Hlogs) as Hlog.
simp_sub in Hlog.
simpl in Hlog.
destruct Hlog as (_ & _ & Haeq).
simp_sub.
simpl.
do 2 eexists; do2 4 split; eauto; [].
eauto using aeq_symm, aeq_trans; done.

(* extpi *)
intros G k1 k2 k3 c Hofc IH1 _ IH2 D D' s s' Hwf Hlogs.
so (ofc_reg _#3 Hwf Hofc) as Hofk.
invert Hofk.
intros Hofk1 _; clear Hofk.
simp_sub.
simpl.
#4 do 4 eexists; do2 5 split; eauto.
  so (IH1 _#4 Hwf Hlogs) as Hlog.
  simp_sub in Hlog.
  simpl in Hlog.
  destruct Hlog as (e1 & e1' & e2 & e2' & Heq & Heq' & Hlog1 & _).
  injection Heq; clear Heq; intros; subst e1 e2.
  injection Heq'; clear Heq'; intros; subst e1' e2'.
  assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub.
  #2 exploit (IH2 D2 D2' (dot d (compose s (sh i))) (dot d' (compose s' (sh i)))) as Hlog; auto using wf_cn.
    apply logsub_cons; eauto using logsub_mono; [].
    simp_sub in Hlogd.
    assumption.

    simp_sub in Hlog.
    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub.
  #2 exploit (IH2 D2 D2' (dot d (compose s (sh i))) (dot d' (compose s (sh i)))) as Hlog; auto using wf_cn.
    apply logsub_cons; eauto using logsub_mono, logsub_self_left; [].
    simp_sub in Hlogd.
    assumption.

    simp_sub in Hlog.
    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub.
  #2 exploit (IH2 D2 D2' (dot d (compose s' (sh i))) (dot d' (compose s' (sh i)))) as Hlog; auto using wf_cn.
    apply logsub_cons; eauto using logsub_mono, logsub_self_right; [].
    simp_sub in Hlogd.
    assumption.

    simp_sub in Hlog.
    assumption.

(* extsigma *)
intros G k1 k2 c Hofc1 IH1 _ IH2 Hofk2 IH3 D D' s s' Hwf Hlogs.
so (ofc_reg _#3 Hwf Hofc1) as Hofk1.
so (ofk_hkd _ _ Hofk2) as Hhkd2.
simp_sub.
simpl.
#4 do 4 eexists; do2 6 split; eauto.
  simp_sub.
  so (IH2 _#4 Hwf Hlogs) as Hlog.
  simp_sub in Hlog.
  unfold subst1 in Hlog.
  rewrite -> (subst_skel _ _ Hhkd2) in Hlog; [].
  assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH3; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; done.

    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH3; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_left; eauto; done.

    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH3; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_right; eauto; done.

    assumption.

(* subsume *)
intros G k k' c _ IH1 _ IH2 D D' s s' Hwf Hlogs.
apply IH2; auto; done.

(* refl *)
intros G c k _ IH D D' s s' Hwf Hlogs.
apply IH; auto; done.

(* symm *)
intros G c c' k _ IH D D' s s' Hwf Hlogs.
apply logc_symm; [].
apply IH; auto; [].
apply logsub_symm; auto; done.

(* trans *)
intros G c1 c2 c3 k _ IH1 _ IH2 D D' s s' Hwf Hlogs.
apply (logc_trans_left _#4 (subst s c2) _ _ (subst s k)).
  apply IH1; eauto using logsub_self_left; done.

  apply IH2; auto; done.

(* lam *)
intros G k1 k1' k2 c c' Heqk1 IH1 _ IH2 D D' s s' Hwf Hlogs.
so (eqk_reg _#3 Hwf Heqk1) as (Hofk1 & _).
simp_sub.
simpl.
#4 do 4 eexists; do2 5 split; eauto.
  apply (logk_diag_left _#4 (rotate5 IH1 Hwf)); auto; done.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  #3 apply (logc_head_expand _#5 (subst (dot d (compose s (sh i))) c) (subst (dot d' (compose s' (sh i))) c')).
    apply IH2; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_mono; done.

    so (@headred_beta D2 (subst (compose s (sh i)) k1) (subst (dot (var 0) (compose s (sh (S i)))) c) d) as Hred.
    simp_sub in Hred.
    assumption.

    so (@headred_beta D2' (subst (compose s' (sh i)) k1') (subst (dot (var 0) (compose s' (sh (S i)))) c') d') as Hred.
    simp_sub in Hred.
    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  #3 apply (logc_head_expand _#5 (subst (dot d (compose s (sh i))) c) (subst (dot d' (compose s (sh i))) c)).
    apply (logc_diag_left _#6 (rotate5 IH2 (wf_cn Hwf Hofk1))); [].
    apply logsub_cons; eauto using logsub_mono, logsub_self_left; done.

    so (@headred_beta D2 (subst (compose s (sh i)) k1) (subst (dot (var 0) (compose s (sh (S i)))) c) d) as Hred.
    simp_sub in Hred.
    assumption.

    so (@headred_beta D2' (subst (compose s (sh i)) k1) (subst (dot (var 0) (compose s (sh (S i)))) c) d') as Hred.
    simp_sub in Hred.
    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  #3 apply (logc_head_expand _#5 (subst (dot d (compose s' (sh i))) c') (subst (dot d' (compose s' (sh i))) c')).
    apply (logc_diag_right _#6 (rotate5 IH2 (wf_cn Hwf Hofk1))); [].
    apply logsub_cons; eauto using logsub_mono, logsub_self_right; done.

    so (@headred_beta D2 (subst (compose s' (sh i)) k1') (subst (dot (var 0) (compose s' (sh (S i)))) c') d) as Hred.
    simp_sub in Hred.
    assumption.

    so (@headred_beta D2' (subst (compose s' (sh i)) k1') (subst (dot (var 0) (compose s' (sh (S i)))) c') d') as Hred.
    simp_sub in Hred.
    assumption.

(* app *)
intros G k1 k2 c1 c2 c1' c2' Heqc IH1 _ IH2 D D' s s' Hwf Hlogs.
so (IH1 _#4 Hwf Hlogs) as Hlogfn.
so (IH2 _#4 Hwf Hlogs) as Hlogarg.
simp_sub in Hlogfn.
simpl in Hlogfn.
destruct Hlogfn as (e1 & e1' & e2 & e2' & Heq & Heq' & Hlog1 & Hlog2 & Hlog2kl & Hlog2kr).
injection Heq; clear Heq; intros; subst e1 e2.
injection Heq'; clear Heq'; intros; subst e1' e2'.
#2 exploit (Hlog2 0 D D' (subst s c2) (subst s' c2')) as Hlogapp; auto with alg.
  simp_sub; assumption.
simp_sub in Hlogapp.
simp_sub.
so (ofk_hkd _ _ (eqc_reg _#4 Hwf Heqc ander ander)) as Hhkd.
invert Hhkd.
intros _ Hhkd2.
unfold subst1.
rewrite -> (subst_skel (dot c2 id) _ Hhkd2); [].
eapply logc_adjust_right; eauto; [].
apply logk_symm; [].
#2 exploit (Hlog2kr 0 D' D' (subst s' c2) (subst s' c2')) as Hlog2kr'; auto with alg.
  simp_sub.
  apply IH2; eauto using logsub_self_right; done.

  simp_sub in Hlog2kr'.
  eapply logc_reg; eauto; done.

(* pair *)
intros G k1 k2 c1 c1' c2 c2' Heqc1 IH1 _ IH2 Hofk2 IH3 D D' s s' Hwf Hlogs.
so (eqc_reg _#4 Hwf Heqc1) as (_ & _ & Hofk1).
so (ofk_hkd _ _ Hofk2) as Hhkd.
simp_sub.
simpl.
#5 do 4 eexists; do2 6 split; eauto.
  apply (logc_head_expand _#5 (subst s c1) (subst s' c1')); auto with alg; done.

  simp_sub.
  apply (logc_head_expand _#5 (subst s c2) (subst s' c2')); auto with alg; [].
  #3 apply (logc_adjust _#5 (subst (dot (subst s c1) s) k2) (subst (dot (subst s' c1') s') k2)).
    apply logk_symm; [].
    apply IH3; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_self_left; [].
    apply (logc_head_expand_left _#4 (subst s c1)); auto with alg; [].
    apply (logc_self_left _ _ D _ (subst s c1') _ (subst s k1)); [].
    apply IH1; eauto using logsub_self_left; done.

    apply logk_symm; [].
    apply IH3; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_self_right; [].
    apply (logc_head_expand_left _#4 (subst s' c1')); auto with alg; [].
    apply (logc_self_right _ D' _ (subst s' c1) _ (subst s' k1)); [].
    apply IH1; eauto using logsub_self_right; done.

    exploit (IH2 D D' s s') as Hlogpi2; auto; [].
    simp_sub in Hlogpi2.
    unfold subst1 in Hlogpi2.
    rewrite -> (subst_skel _ _ Hhkd) in Hlogpi2; [].
    eapply logc_adjust_right; eauto; [].
    apply IH3; auto using wf_cn; [].
    apply logsub_cons; eauto using logsub_self_right; done.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH3; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; done.

    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH3; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_left; eauto; done.

    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH3; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_right; eauto; done.

    assumption.

(* pi1 *)
intros G k1 k2 c c' _ IH D D' s s' Hwf Hlogs.
simp_sub.
so (IH _#4 Hwf Hlogs) as Hlog.
simp_sub in Hlog.
simpl in Hlog.
destruct Hlog as (e1 & e1' & e2 & e2' & Heq & Heq' & Hlog1 & Hlog2 & _).
injection Heq; clear Heq; intros; subst e1 e2.
injection Heq'; clear Heq'; intros; subst e1' e2'.
assumption.

(* pi2 *)
intros G k1 k2 c c' Heqc IH D D' s s' Hwf Hlogs.
simp_sub.
so (IH _#4 Hwf Hlogs) as Hlog.
simp_sub in Hlog.
simpl in Hlog.
destruct Hlog as (e1 & e1' & e2 & e2' & Heq & Heq' & Hlog1 & Hlog2 & Hlog2k & Hlog2kl & Hlog2kr).
injection Heq; clear Heq; intros; subst e1 e2.
injection Heq'; clear Heq'; intros; subst e1' e2'.
simp_sub in Hlog2.
so (ofk_hkd _ _ (eqc_reg _#4 Hwf Heqc ander ander)) as Hhkd.
invert Hhkd.
intros _ Hhkd2.
unfold subst1.
rewrite -> (subst_skel _ _ Hhkd2); [].
eapply logc_adjust_right; eauto; [].
apply logk_symm; [].
#2 exploit (Hlog2kr 0 D' D' (cn_pi1 (subst s' c)) (cn_pi1 (subst s' c'))) as Hlog2kr'; auto with alg.
  simp_sub.
  so (IH _#4 Hwf (logsub_self_right _#5 Hlogs)) as Hlog'.
  simp_sub in Hlog'.
  simpl in Hlog'.
  destruct Hlog' as (e1 & e1' & e2 & e2' & Heq & Heq' & Hlog1' & _).
  injection Heq; clear Heq; intros; subst e1 e2.
  injection Heq'; clear Heq'; intros; subst e1' e2'.
  assumption.

  simp_sub in Hlog2kr'.
  assumption.

(* arrow *)
intros G t1 t1' t2 t2' _ IH1 _ IH2 D D' s s' Hwf Hlogs.
simp_sub.
simpl.
do2 2 split; auto; [].
apply (@aeq_type _#4 (cn_arrow (subst s t1) (subst s t2)) (cn_arrow (subst s' t1') (subst s' t2'))); auto with alg; [].
#2 apply peq_arrow.
  so (IH1 _#4 Hwf Hlogs) as Hlog.
  simpl in Hlog.
  destruct Hlog as (_ & _ & Haeq).
  assumption.

  so (IH2 _#4 Hwf Hlogs) as Hlog.
  simpl in Hlog.
  destruct Hlog as (_ & _ & Haeq).
  assumption.

(* prod *)
intros G t1 t1' t2 t2' _ IH1 _ IH2 D D' s s' Hwf Hlogs.
simp_sub.
simpl.
do2 2 split; auto; [].
apply (@aeq_type _#4 (cn_prod (subst s t1) (subst s t2)) (cn_prod (subst s' t1') (subst s' t2'))); auto with alg; [].
#2 apply peq_prod.
  so (IH1 _#4 Hwf Hlogs) as Hlog.
  simpl in Hlog.
  destruct Hlog as (_ & _ & Haeq).
  assumption.

  so (IH2 _#4 Hwf Hlogs) as Hlog.
  simpl in Hlog.
  destruct Hlog as (_ & _ & Haeq).
  assumption.

(* all *)
intros G k k' t t' Heqk IH1 _ IH2 D D' s s' Hwf Hlogs.
so (eqk_reg _#3 Hwf Heqk) as (Hofk & _).
simp_sub.
simpl.
do2 2 split; auto; [].
apply (@aeq_type _#4 (cn_all (subst s k) (subst (dot (var 0) (compose s sh1)) t)) (cn_all (subst s' k') (subst (dot (var 0) (compose s' sh1)) t'))); auto with alg; [].
#2 apply peq_all.
  apply (main_lemma (skel k) andel); [].
  apply IH1; auto; done.

  #2 exploit (IH2 (D; cl_cn (subst s k)) (D'; cl_cn (subst s' k')) (dot (var 0) (compose s sh1)) (dot (var 0) (compose s' sh1))) as Hlog; auto using wf_cn.
    #2 apply logsub_cons.
      eapply logsub_mono; eauto using extend_1; done.

      #2 apply (logc_adjust_right _#5 (subst (compose s' sh1) k')).
        apply logk_symm; [].
        rewrite -> !subst_compose.
        eapply logk_mono; eauto using extend_1; [].
        apply IH1; eauto using logsub_self_right; done.

        #2 apply (main_lemma (skel k) ander ander); auto with alg.
          rewrite -> !subst_compose.
          apply peq_var; auto using index_0; done.

          apply IH1; auto; [].
          eapply logsub_mono; eauto using extend_1; done.

    simp_sub in Hlog.
    destruct Hlog as (_ & _ & Haeq).
    assumption.

(* exists *)
intros G k k' t t' Heqk IH1 _ IH2 D D' s s' Hwf Hlogs.
so (eqk_reg _#3 Hwf Heqk) as (Hofk & _).
simp_sub.
simpl.
do2 2 split; auto; [].
apply (@aeq_type _#4 (cn_exists (subst s k) (subst (dot (var 0) (compose s sh1)) t)) (cn_exists (subst s' k') (subst (dot (var 0) (compose s' sh1)) t'))); auto with alg; [].
#2 apply peq_exists.
  apply (main_lemma (skel k) andel); [].
  apply IH1; auto; done.

  #2 exploit (IH2 (D; cl_cn (subst s k)) (D'; cl_cn (subst s' k')) (dot (var 0) (compose s sh1)) (dot (var 0) (compose s' sh1))) as Hlog; auto using wf_cn.
    #2 apply logsub_cons.
      eapply logsub_mono; eauto using extend_1; done.

      #2 apply (logc_adjust_right _#5 (subst (compose s' sh1) k')).
        apply logk_symm; [].
        rewrite -> !subst_compose.
        eapply logk_mono; eauto using extend_1; [].
        apply IH1; eauto using logsub_self_right; done.

        #2 apply (main_lemma (skel k) ander ander); auto with alg.
          rewrite -> !subst_compose.
          apply peq_var; auto using index_0; done.

          apply IH1; auto; [].
          eapply logsub_mono; eauto using extend_1; done.

    simp_sub in Hlog.
    destruct Hlog as (_ & _ & Haeq).
    assumption.

(* sing *)
intros G c c' _ IH D D' s s' Hwf Hlogs.
so (IH _#4 Hwf Hlogs) as Hlog.
simp_sub in Hlog.
simpl in Hlog.
destruct Hlog as (_ & _ & Haeq).
simp_sub.
simpl.
do 2 eexists; do2 4 split; eauto using aeq_symm, aeq_trans; [].
so (logc_diag_left _#6 (rotate5 IH Hwf) _#4 Hlogs) as Hlog'.
simp_sub in Hlog'.
simpl in Hlog'.
destruct Hlog' as (_ & _ & Haeq').
assumption.

(* singelim *)
intros G c c' _ IH D D' s s' Hwf Hlogs.
simp_sub.
simpl.
do2 2 split; auto; [].
so (IH _#4 Hwf Hlogs) as Hlog.
simp_sub in Hlog; simpl in Hlog.
destruct Hlog as (e & e' & Heq & Heq' & Haeqb & Haeqc & Haeqbc).
injection Heq; clear Heq; intros; subst e.
injection Heq'; clear Heq'; intros; subst e'.
eauto using aeq_symm, aeq_trans; done.

(* extpi *)
intros G k1 k2 k3 k3' c c' Hofc IH1 _ IH2 _ IH3 D D' s s' Hwf Hlogs.
so (ofc_reg _#3 Hwf Hofc) as Hofk.
invert Hofk.
intros Hofk1 _; clear Hofk.
simp_sub.
simpl.
#4 do 4 eexists; do2 5 split; eauto.
  so (IH1 _#4 Hwf Hlogs) as Hlog.
  simp_sub in Hlog.
  simpl in Hlog.
  destruct Hlog as (e1 & e1' & e2 & e2' & Heq & Heq' & Hlog1 & _).
  injection Heq; clear Heq; intros; subst e1 e2.
  injection Heq'; clear Heq'; intros; subst e1' e2'.
  assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub.
  #2 exploit (IH3 D2 D2' (dot d (compose s (sh i))) (dot d' (compose s' (sh i)))) as Hlog; auto using wf_cn.
    apply logsub_cons; eauto using logsub_mono; [].
    simp_sub in Hlogd.
    assumption.

    simp_sub in Hlog.
    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub.
  #2 exploit (logc_diag_left _#6 (rotate5 IH3 (wf_cn Hwf Hofk1)) D2 D2' (dot d (compose s (sh i))) (dot d' (compose s (sh i)))) as Hlog; auto using wf_cn.
    apply logsub_cons; eauto using logsub_mono, logsub_self_left; [].
    simp_sub in Hlogd.
    assumption.

    simp_sub in Hlog.
    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub.
  #2 exploit (logc_diag_right _#6 (rotate5 IH3 (wf_cn Hwf Hofk1)) D2 D2' (dot d (compose s' (sh i))) (dot d' (compose s' (sh i)))) as Hlog; auto using wf_cn.
    apply logsub_cons; eauto using logsub_mono, logsub_self_right; [].
    simp_sub in Hlogd.
    assumption.

    simp_sub in Hlog.
    assumption.

(* extpiw *)
intros G k1 k2 k3 c c' Heqc IH1 _ IH2 D D' s s' Hwf Hlogs.
so (eqc_reg _#4 Hwf Heqc) as (_ & _ & Hofk).
invert Hofk.
intros Hofk1 _; clear Hofk.
simp_sub.
simpl.
#4 do 4 eexists; do2 5 split; eauto.
  so (IH1 _#4 Hwf Hlogs) as Hlog.
  simp_sub in Hlog.
  simpl in Hlog.
  destruct Hlog as (e1 & e1' & e2 & e2' & Heq & Heq' & Hlog1 & _).
  injection Heq; clear Heq; intros; subst e1 e2.
  injection Heq'; clear Heq'; intros; subst e1' e2'.
  assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub.
  #2 exploit (IH2 D2 D2' (dot d (compose s (sh i))) (dot d' (compose s' (sh i)))) as Hlog; auto using wf_cn.
    apply logsub_cons; eauto using logsub_mono; [].
    simp_sub in Hlogd.
    assumption.

    simp_sub in Hlog.
    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub.
  #2 exploit (logc_diag_left _#6 (rotate5 IH2 (wf_cn Hwf Hofk1)) D2 D2' (dot d (compose s (sh i))) (dot d' (compose s (sh i)))) as Hlog; auto using wf_cn.
    apply logsub_cons; eauto using logsub_mono, logsub_self_left; [].
    simp_sub in Hlogd.
    assumption.

    simp_sub in Hlog.
    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub.
  #2 exploit (logc_diag_right _#6 (rotate5 IH2 (wf_cn Hwf Hofk1)) D2 D2' (dot d (compose s' (sh i))) (dot d' (compose s' (sh i)))) as Hlog; auto using wf_cn.
    apply logsub_cons; eauto using logsub_mono, logsub_self_right; [].
    simp_sub in Hlogd.
    assumption.

    simp_sub in Hlog.
    assumption.

(* extsigma *)
intros G k1 k2 c c' Heqc1 IH1 _ IH2 Hofk2 IH3 D D' s s' Hwf Hlogs.
so (eqc_reg _#4 Hwf Heqc1) as (_ & _ & Hofk1).
so (ofk_hkd _ _ Hofk2) as Hhkd2.
simp_sub.
simpl.
#4 do 4 eexists; do2 6 split; eauto.
  simp_sub.
  so (IH2 _#4 Hwf Hlogs) as Hlog.
  simp_sub in Hlog.
  unfold subst1 in Hlog.
  rewrite -> (subst_skel _ _ Hhkd2) in Hlog; [].
  eapply logc_adjust_right; eauto; [].
  apply IH3; auto using wf_cn; [].
  apply logsub_cons; eauto using logsub_self_right; done.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH3; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; done.

    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH3; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_left; eauto; done.

    assumption.

  intros i D2 D2' d d' Hext Hext' Hlogd.
  simp_sub in Hlogd.
  simp_sub.
  apply IH3; auto using wf_cn; [].
  #2 apply logsub_cons.
    eapply logsub_mono; eauto; [].
    eapply logsub_self_right; eauto; done.

    assumption.

(* extone *)
intros.
simp_sub.
simpl.
auto; done.

(* subsume *)
intros G c c' k k' _ IH1 _ IH2 D D' s s' Hwf Hlogs.
apply IH2; auto; done.

(* beta *)
intros G k1 k2 c1 c2 Hofc1 IH1 Hofc2 IH2 D D' s s' Hwf Hlogs.
so (ofc_reg _#3 Hwf Hofc2) as Hofk1.
so (ofk_hkd _ _ (ofc_reg _#3 (wf_cn Hwf Hofk1) Hofc1)) as Hhkd2.
simp_sub.
unfold subst1.
rewrite -> (subst_skel _ _ Hhkd2); [].
#2 apply (logc_head_expand_left _#4 (subst (dot (subst s c1) s) c2)).
  apply IH1; auto using wf_cn; [].
  apply logsub_cons; auto; done.

  so (@headred_beta D (subst s k1) (subst (dot (var 0) (compose s sh1)) c2) (subst s c1)) as Hred.
  simp_sub in Hred.
  assumption.

(* beta1 *)
intros G k1 k2 c1 c2 _ IH1 _ IH2 D D' s s' Hwf Hlogs.
simp_sub.
#2 apply (logc_head_expand_left _#4 (subst s c1)).
  apply IH1; auto; done.

  apply headred_beta1; done.

(* beta2 *)
intros G k1 k2 c1 c2 _ IH1 _ IH2 D D' s s' Hwf Hlogs.
simp_sub.
#2 apply (logc_head_expand_left _#4 (subst s c2)).
  apply IH2; auto; done.

  apply headred_beta2; done.

(* epilogue *)
destruct_all Hind.
do2 4 split; intros; eauto; done.
Qed.


Lemma logsub_id :
  forall G,
    wf G
    -> logsub G G (under (length G) id) (under (length G) id) G.
Proof.
intros G Hwf.
induct Hwf.

(* nil *)
simp_sub.
apply logsub_nil; done.

(* cn *)
intros G k Hwf Hlogs Hofk.
simpl length.
simp_sub.
#2 apply logsub_cons.
  eapply logsub_mono; eauto with alg; done.

  rewrite -> !subst_compose; [].
  #2 apply (main_lemma (skel k) ander ander); auto with alg.
    rewrite -> !subst_under_id; [].
    apply peq_var; auto using index_0; done.

    eapply logk_mono; eauto with alg; [].
    eapply (fundamental_theorem andel); eauto; done.

(* tm *)
intros G t Hwf Hlogs _.
simpl length.
rewrite -> !under_succ; [].
apply logsub_tm; [].
apply (logsub_mono 1 G G); auto using extend_1; done.

(* md *)
intros G k T Hwf Hlogs HofT Hfst.
simpl length.
rewrite -> !under_succ; [].
apply logsub_md; [].
apply (logsub_mono 1 (G; cl_cn k) (G; cl_cn k)); auto using extend_1; [].
#2 apply logsub_cons.
  eapply logsub_mono; eauto with alg; done.

  rewrite -> !subst_compose; [].
  #2 apply (main_lemma (skel k) ander ander); auto with alg.
    rewrite -> !subst_under_id; [].
    apply peq_var; auto using index_0; done.

    eapply logk_mono; eauto with alg; [].
    eapply (fundamental_theorem andel); eauto; [].
    eapply ofs_fst; eauto; done.
Qed.


Lemma aeq_complete :
  forall G c1 c2 k,
    wf G
    -> eqc G c1 c2 k
    -> aeq G G c1 c2 k k.
Proof.
intros G c1 c2 k Hwf Heqc.
apply (main_lemma (skel k) ander andel); [].
so (logsub_id _ Hwf) as Hlogs.
so (fundamental_theorem ander ander ander ander _#8 Heqc Hwf Hlogs) as Hlog.
rewrite -> !subst_under_id in Hlog; [].
assumption.
Qed.
