
Require Import Tactics.
Require Import Sequence.
Require Export TSubstGeneral.
Require Import TSubst.
Require Import Static.
Require Import Dynamic.
Require Import Breduce.
Require Import Regularity.
Require Import Congruence.
Require Adequacy.


Lemma subst_treduce_mreduce :
  (forall G1 G2 s e e',
     subof oof G1 s G2
     -> treduce G2 e e'
     -> treduce G1 (subst s e) (subst s e'))
  /\
  (forall G1 G2 s M M',
     subof oof G1 s G2
     -> mreduce G2 M M'
     -> mreduce G1 (subst s M) (subst s M')).
Proof.
assert (forall G1 G2 s,
          subof oof G1 s G2
          -> subof oof (G1; cl_ucn) (dot (var 0) (compose s sh1)) (G2; cl_ucn)) as Hbindc.
  intros G1 G2 s Hs.
  so (subof_wclo_bind _ oof_behaved oof_wclo _#4 iscl_ucn Hs) as H.
  simp_sub in H.
  assumption.
assert (forall G1 G2 s,
          subof oof G1 s G2
          -> subof oof (G1; cl_utm) (dot (var 0) (compose s sh1)) (G2; cl_utm)) as Hbindt.
  intros G1 G2 s Hs.
  so (subof_wclo_bind _ oof_behaved oof_wclo _#4 iscl_utm Hs) as H.
  simp_sub in H.
  assumption.
assert (forall G1 G2 s,
          subof oof G1 s G2
          -> subof oof (G1; cl_ucn; cl_utm) (dot (var 0) (dot (var 1) (compose s (sh 2)))) (G2; cl_ucn; cl_utm)) as Hbindct.
  intros G1 G2 s Hs.
  so (subof_wclo_bind2 _ oof_behaved oof_wclo _#5 iscl_ucn iscl_utm Hs) as H.
  simp_sub in H.
  assumption.
assert (forall G1 G2 s,
          subof oof G1 s G2
          -> subof oof (G1; cl_ucn; cl_umd (var 0)) (dot (var 0) (dot (var 1) (compose s (sh 2)))) (G2; cl_ucn; cl_umd (var 0))) as Hbindcm.
  intros G1 G2 s Hs.
  so (subof_wclo_bind2 _ oof_behaved oof_wclo _#4 (cl_umd (var 0)) iscl_ucn iscl_umd Hs) as H.
  simp_sub in H.
  assumption.
assert (forall s m1 m, subst (dot (subst s m1) s) m = subst1 (subst s m1) (subst (dot (var 0) (compose s sh1)) m)) as Hcomm by (intros; simp_sub; reflexivity).
assert (forall s m1 m2 m, subst (dot (subst s m1) (dot (subst s m2) s)) m = subst (dot (subst s m1) (dot (subst s m2) id)) (subst (dot (var 0) (dot (var 1) (compose s (sh 2)))) m)) as Hcomm2 by (intros; simp_sub; reflexivity).
assert (forall G1 G2 s, subof oof G1 s G2 -> subof tof G1 s G2) as Hooftof.
  intros.
  eapply subof_mono; try eassumption; eauto using oof_tof; done.
#2 exploit
  (breduce_ind
     (fun G2 e e' =>
        forall G1 s,
          subof oof G1 s G2
          -> treduce G1 (subst s e) (subst s e'))
     (fun G2 M M' =>
        forall G1 s,
          subof oof G1 s G2
          -> mreduce G1 (subst s M) (subst s M'))) as Hind;
  try (intros; simp_sub; rewrite -> ?Hcomm; rewrite -> ?Hcomm2; eauto using subst_tvalue, subst_mvalue, subst_fstm with reduce; done).

(* fix2 *)
intros G t e G1 s H.
simp_sub.
repl (tm_fix (subst (compose s sh1) t) (subst (compose s sh1) e)) with (shift1 (tm_fix (subst s t) (subst s e))) by (simp_sub; reflexivity).
apply treduce_fix2; done.

(* epilogue *)
destruct Hind; split; eauto; done.
Qed.


Lemma subst_treduce :
  forall G1 G2 s e e',
    subof oof G1 s G2
    -> treduce G2 e e'
    -> treduce G1 (subst s e) (subst s e').
Proof.
exact (subst_treduce_mreduce andel).
Qed.


Lemma subst_mreduce :
  forall G1 G2 s M M',
    subof oof G1 s G2
    -> mreduce G2 M M'
    -> mreduce G1 (subst s M) (subst s M').
Proof.
exact (subst_treduce_mreduce ander).
Qed.



Lemma reduce_compatible_strong :
  compatible eqk eqc eqs (fun G e e' t => treduce G e e') (fun G p M M' T => mreduce G M M').
Proof.
unfold compatible.
#10 split;
[intros G e e' t _ H; induct H | intros G p M M' T _ H; induct H ];
eauto with reduce.

(* lam *)
intros G t1 t1' t2 e e' _ Hred.
apply treduce_lam; [].
rewrite <- (subst_dot0_sh e); rewrite <- (subst_dot0_sh e'); [].
eapply subst_treduce; eauto; [].
apply subof_dot; eauto with static sequence; [].
simp_sub.
apply oof_tm; auto with dynamic sequence; done.

(* plam *)
intros G k k' t e e' _ Hred.
apply treduce_plam; [].
rewrite <- (subst_dot0_sh e); rewrite <- (subst_dot0_sh e'); [].
eapply subst_treduce; eauto; [].
apply subof_dot; eauto with static sequence; [].
simp_sub.
apply oof_cn; done.

(* unpack *)
intros G k t t' e1 e1' e2 e2' Hred1 Hred2 _.
apply treduce_unpack1; auto; [].
rewrite <- (subst_dot01_sh e2); rewrite <- (subst_dot01_sh e2'); [].
eapply subst_treduce; eauto; [].
#2 apply subof_dot.
  apply subof_dot; eauto with static sequence; [].
  simp_sub.
  apply oof_cn; done.

  simp_sub.
  apply oof_tm; auto with dynamic sequence; done.

(* lett *)
intros G t1 t2 e1 e1' e2 e2' Hred1 Hred2.
apply treduce_lett1; auto; [].
rewrite <- (subst_dot0_sh e2); rewrite <- (subst_dot0_sh e2'); [].
eapply subst_treduce; eauto; [].
apply subof_dot; eauto with static sequence; [].
simp_sub.
apply oof_tm; auto with dynamic sequence; done.

(* letm *)
intros G T k t M M' e e' Hred1 _ Hred2 _.
apply treduce_letm1; auto; [].
rewrite <- (subst_dot01_sh e); rewrite <- (subst_dot01_sh e'); [].
eapply subst_treduce; eauto; [].
#2 apply subof_dot.
  apply subof_dot; eauto with static sequence; [].
  simp_sub.
  apply oof_cn; done.

  simp_sub.
  repl (var 1) with (subst (sh 1) (var 0)) by (simp_sub; reflexivity).
  apply oof_md; eauto with static dynamic sequence; done.


(* lamgn *)
intros G T1 T1' T2 k1 M M' _ _ Hred.
apply mreduce_lamgn; [].
rewrite <- (subst_dot01_sh M); rewrite <- (subst_dot01_sh M'); [].
eapply subst_mreduce; eauto; [].
#2 apply subof_dot.
  apply subof_dot; eauto with static sequence; [].
  simp_sub.
  apply oof_cn; done.

  simp_sub.
  repl (var 1) with (subst (sh 1) (var 0)) by (simp_sub; reflexivity).
  apply oof_md; eauto with static dynamic sequence; done.

(* lamap *)
intros G T1 T1' T2 k1 M M' _ _ Hred.
apply mreduce_lamap; [].
rewrite <- (subst_dot01_sh M); rewrite <- (subst_dot01_sh M'); [].
eapply subst_mreduce; eauto; [].
#2 apply subof_dot.
  apply subof_dot; eauto with static sequence; [].
  simp_sub.
  apply oof_cn; done.

  simp_sub.
  repl (var 1) with (subst (sh 1) (var 0)) by (simp_sub; reflexivity).
  apply oof_md; eauto with static dynamic sequence; done.

(* unpack *)
intros G k t T T' e e' M M' Hred1 Hred2 _.
apply mreduce_unpack1; auto; [].
rewrite <- (subst_dot01_sh M); rewrite <- (subst_dot01_sh M'); [].
eapply subst_mreduce; eauto; [].
#2 apply subof_dot.
  apply subof_dot; eauto with static sequence; [].
  simp_sub.
  apply oof_cn; done.

  simp_sub.
  apply oof_tm; auto with dynamic sequence; done.

(* lett *)
intros G p t T e e' M M' Hred1 Hred2.
apply mreduce_lett1; auto; [].
rewrite <- (subst_dot0_sh M); rewrite <- (subst_dot0_sh M'); [].
eapply subst_mreduce; eauto; [].
apply subof_dot; eauto with static sequence; [].
simp_sub.
apply oof_tm; auto with dynamic sequence; done.

(* letm *)
intros G T1 T2 T2' k1 M1 M1' M2 M2' Hred1 _ Hred2 _.
apply mreduce_letm1; auto; [].
rewrite <- (subst_dot01_sh M2); rewrite <- (subst_dot01_sh M2'); [].
eapply subst_mreduce; eauto; [].
#2 apply subof_dot.
  apply subof_dot; eauto with static sequence; [].
  simp_sub.
  apply oof_cn; done.

  simp_sub.
  repl (var 1) with (subst (sh 1) (var 0)) by (simp_sub; reflexivity).
  apply oof_md; eauto with static dynamic sequence; done.
Qed.


Lemma reduce_compatible_weak :
  compatible samek samec sames (fun G e e' t => treduce G e e') (fun G p M M' T => mreduce G M M').
Proof.
#4 apply (compatible_mono _ eqk _ eqc _ eqs).
  intros G k k' H.
  invert H; intros; subst; eauto with static; done.

  intros G c c' k H.
  invert H; intros; subst; eauto with static; done.

  intros G T T' H.
  invert H; intros; subst; eauto with static; done.

  exact reduce_compatible_strong.
Qed.


Definition treducer := treg (fun G e e' t => treduce G e e').
Definition mreducer := mreg (fun G p M M' T => mreduce G M M').


Lemma reduce_csubstitutive :
  csubstitutive (fun G e e' t => treduce G e e') (fun G p M M' T => mreduce G M M').
Proof.
split.
  intros.
  eapply subst_treduce; eauto; [].
  eapply subof_mono; try eassumption; eauto using aof_oof; done.

  intros.
  eapply subst_mreduce; eauto; [].
  eapply subof_mono; try eassumption; eauto using aof_oof; done.
Qed.


Lemma reducer_semicongruence :
  semicongruence treducer mreducer.
Proof.
#4 apply reg_semicongruence.
  split.
    intros; apply treduce_refl; done.

    intros; apply mreduce_refl; done.

  split.
    intros; eapply treduce_trans; eauto; done.

    intros; eapply mreduce_trans; eauto; done.

  exact reduce_csubstitutive.

  exact reduce_compatible_weak.
Qed.


Lemma anti_reducer_semicongruence :
  semicongruence (treg (fun G e e' t => treduce G e' e)) (mreg (fun G p M M' T => mreduce G M' M)).
Proof.
#3 apply (semicongruence_ext
         (fun G e e' t => treg (fun G e e' t => treduce G e e') G e' e t) _
         (fun G p M M' T => mreg (fun G p M M' T => mreduce G M M') G p M' M T)).
  intros G e e' t.
  split; intros; apply treg_transpose; assumption.

  split; intros; apply mreg_transpose; assumption.

  apply transpose_semicongruence; exact reducer_semicongruence.
Qed.


Lemma reducer_consistent :
  consistent mreducer.
Proof.
apply reg_consistent; [].
intros M M' T Hof Hof' Hred Hhalt.
refine (Adequacy.adequacy_mreduce M M' _#7 andel _); eauto.
Qed.


Lemma anti_reducer_consistent :
  consistent (mreg (fun G p M M' T => mreduce G M' M)).
Proof.
apply reg_consistent; [].
intros M M' T Hof Hof' Hred Hhalt.
refine (Adequacy.adequacy_mreduce M' M _#7 ander _); eauto.
Qed.
